/* A lexical scanner generated by flex */

/* scanner skeleton version:
 * $Header: /home/horse/u0/vern/flex/RCS/flex.skel,v 2.16 90/08/03 14:09:36 vern Exp Locker: vern $
 */

#define FLEX_SCANNER

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <osfcn.h>

/* use prototypes in function declarations */
#define YY_USE_PROTOS

/* the "const" storage-class-modifier is valid */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#ifdef __GNUC__
#include <stddef.h>
void *malloc( size_t );
void free( void* );
#else
#include <stdlib.h>
#endif	/* __GNUC__ */

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */


#ifdef __TURBOC__
#define YY_USE_CONST
#endif


#ifndef YY_USE_CONST
#define const
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
/* we can't get here if it's an ANSI C compiler, or a C++ compiler,
 * so it's got to be a K&R compiler, and therefore there's no standard
 * place from which to include these definitions
 */
char *malloc();
int free();
int read();
#endif


/* amount of stuff to slurp up with each read */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* returned upon end-of-file */
#define YY_END_TOK 0

/* copy whatever the last rule matched to the standard output */

/* cast to (char *) is because for 8-bit chars, yytext is (unsigned char *) */
/* this used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite()
 */
#define ECHO (void) fwrite( (char *) yytext, yyleng, 1, yyout )

/* gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#define YY_INPUT(buf,result,max_size) \
	if ( (result = read( fileno(yyin), (char *) buf, max_size )) < 0 ) \
	    YY_FATAL_ERROR( "read() in flex scanner failed" );
#define YY_NULL 0

/* no semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#define yyterminate() return ( YY_NULL )

/* report a fatal error */

/* The funky do-while is used to turn this macro definition into
 * a single C statement (which needs a semi-colon terminator).
 * This avoids problems with code like:
 *
 * 	if ( something_happens )
 *		YY_FATAL_ERROR( "oops, the something happened" );
 *	else
 *		everything_okay();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the YY_FATAL_ERROR() call.
 */

#define YY_FATAL_ERROR(msg) \
	do \
		{ \
		(void) fputs( msg, stderr ); \
		(void) putc( '\n', stderr ); \
		exit( 1 ); \
		} \
	while ( 0 )

/* default yywrap function - always treat EOF as an EOF */
#define yywrap() 1

/* enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN
 */
#define BEGIN yy_start = 1 + 2 *

/* action number for EOF rule of a given start state */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* special action meaning "start processing a new file" */
#define YY_NEW_FILE \
	do \
		{ \
		yy_init_buffer( yy_current_buffer, yyin ); \
		yy_load_buffer_state(); \
		} \
	while ( 0 )

/* default declaration of generated scanner - a define so the user can
 * easily add parameters
 */
#define YY_DECL int yylex YY_PROTO(( void )) 

/* code executed at the end of each rule */
#define YY_BREAK break;

#define YY_END_OF_BUFFER_CHAR 0

#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE (YY_READ_BUF_SIZE * 2) /* size of default input buffer */
#endif

typedef struct yy_buffer_state *YY_BUFFER_STATE;

#define YY_CHAR char
#define INITIAL 0

#ifndef lint
static char *RCSid = "$Id: lexsrc.l,v 1.7 1992/04/05 20:40:21 anders Exp anders $";
#endif

/*
 * Copyright (C) 1992 Anders Christensen <anders@solan.unit.no>
 * Read file README for more information on copying
 */

/*
 * $Log: lexsrc.l,v $
 * Revision 1.7  1992/04/05  20:40:21  anders
 * Added copyright notice
 * Added support for traceing, had to set up limits for allocations
 *
 * Revision 1.6  1992/03/23  05:13:36  anders
 * Fixed bug that (randomly) didn't recognize "12"x as a hexstring
 *    because of the double-quotes (singel-quote were ok)
 *
 * Revision 1.5  1992/03/22  00:44:58  anders
 * Made the code compatible with standard lex. This includes:
 *    - directives for space allocations
 *    - setting initial startcondition through yy_start
 *    - checking for FLEX_SCANNER to see if yy_init should be set
 *    - making all rules case-insensitive.
 *
 * Revision 1.4  1992/02/29  13:27:39  anders
 * Fixed two bugs.
 * When parsing with value, the value-mode ends at 'with'
 * When reading input, ',' the interpreter will not try to interpret
 *    any ',' as a line continuation.
 *
 * Revision 1.3  1991/04/05  23:31:47  anders
 * Added a cludge to make the  #include <rexx.h>  not include any
 * of the system include-files ... this ought to be done *better*
 *
 * Revision 1.2  90/12/10  17:38:26  anders
 * Removed bug that made it impossible to use with as a variable name
 * in a parse-statement (f.ex  parse var x one with two )
 * 
 * Revision 1.1  90/08/08  02:28:41  anders
 * Initial revision
 * 
 * Revision 1.1  90/08/08  02:23:41  anders
 * Initial revision
 * 
 */

#define NO_INCLUDE
#include "rexx.h"
#include "symbols.h"

#ifdef FLEX_SCANNER
#undef YY_INPUT
#define YY_INPUT(buf,result,max_size)\
     { int c=mygetchar(); result=((c==EOF)?YY_NULL:(buf[0]=c,1)) ; }
#else
#undef input
#define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):mygetchar())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif


int obs_with=0, in_do=0, in_then=0, commentlevel=0, dontlast=0 ;
int sum=0, flag=1, nnextstart=0, nnextline ;
extern int nextline ;
int i, j, k, code=0, next=0, in_parse=0, support=0, in_trace=0, itflag=0 ;
int seek_with=0 ;
static int firsttime=0, prev=0, last=0 ;
char retvalue[256], char1, ch ;
extern int thischar, nextstart, tstart, tline ;
char *rmspc( char *instr ) ;
void striptext( char *text ) ;
#define nothing 1
#define comm 2
#define trace 3
#define signal 4
#define sigtype 5
#define procd 6
#define parse 7
#define then 8
#define with 9
#define numeric 10
#define do1 11
#define other 12
#define value1 13
#define ifcont 14
int yy_startcond=comm ;

/* done after the current pattern has been matched and before the
 * corresponding action - sets up yytext
 */
#define YY_DO_BEFORE_ACTION \
	yytext = yy_bp; \
	yyleng = yy_cp - yy_bp; \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* return all but the first 'n' matched characters back to the input stream */
#define yyless(n) \
	do \
		{ \
		/* undo effects of setting up yytext */ \
		*yy_cp = yy_hold_char; \
		yy_c_buf_p = yy_cp = yy_bp + n; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext )


struct yy_buffer_state
    {
    FILE *yy_input_file;

    YY_CHAR *yy_ch_buf;		/* input buffer */
    YY_CHAR *yy_buf_pos;	/* current position in input buffer */

    /* size of input buffer in bytes, not including room for EOB characters */
    int yy_buf_size;	

    /* number of characters read into yy_ch_buf, not including EOB characters */
    int yy_n_chars;

    int yy_eof_status;		/* whether we've seen an EOF on this buffer */
#define EOF_NOT_SEEN 0
    /* "pending" happens when the EOF has been seen but there's still
     * some text process
     */
#define EOF_PENDING 1
#define EOF_DONE 2
    };

static YY_BUFFER_STATE yy_current_buffer;

/* we provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state"
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed */
static YY_CHAR yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */



#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

#ifndef YY_USER_INIT
#define YY_USER_INIT
#endif

extern YY_CHAR *yytext;
extern int yyleng;
extern FILE *yyin, *yyout;

YY_CHAR *yytext;
int yyleng;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

#define YY_END_OF_BUFFER 113
typedef int yy_state_type;
static const short int yy_acclist[1534] =
    {   0,
      113,  110,  111,  112,  109,  111,  112,    3,  112,   84,
      111,  112,  111,  112,   91,  110,  111,  112,   94,  111,
      112,  111,  112,   86,  111,  112,   85,  111,  112,   92,
      111,  112,   89,  111,  112,   87,  111,  112,   88,  111,
      112,   82,  108,  111,  112,   90,  111,  112,   82,   83,
      111,  112,  111,  112,    3,  111,  112,   99,  111,  112,
       95,  110,  111,  112,   97,  111,  112,   84,  111,  112,
       84,  111,  112,   84,  111,  112,   84,  111,  112,   84,
      111,  112,   96,  110,  111,  112,   96,  111,  112,   93,
      111,  112,    1,  110,  111,  112,    4,  110,  111,  112,

        4,  109,  111,  112,    4,   84,  111,  112,    4,  111,
      112,    4,   91,  110,  111,  112,    4,   94,  111,  112,
        4,  111,  112,    4,   86,  111,  112,    4,   85,  111,
      112,    4,   92,  111,  112,    4,   89,  111,  112,    4,
       87,  111,  112,    4,   88,  111,  112,    4,   82,  108,
      111,  112,    4,   90,  111,  112,    4,   82,   83,  111,
      112,    4,  111,  112,    3,    4,  111,  112,    4,   99,
      111,  112,    4,   95,  110,  111,  112,    4,   97,  111,
      112,    4,   84,  111,  112,    4,   84,  111,  112,    4,
       84,  111,  112,    4,   84,  111,  112,    4,   84,  111,

      112,    4,   96,  110,  111,  112,    4,   96,  111,  112,
        4,   93,  111,  112,    1,    4,  110,  111,  112,  109,
      111,  112,   84,  111,  112,   82,  108,  111,  112,   82,
       83,  111,  112,   84,  111,  112,   84,  111,  112,   84,
      111,  112,   84,  111,  112,   84,  111,  112,   84,  111,
      112,   84,  111,  112,   84,  111,  112,   84,  111,  112,
       84,  111,  112,   84,  111,  112,   84,  111,  112,   84,
      111,  112,   84,  111,  112,   84,  111,  112,   84,  111,
      112,   84,  111,  112,    1,  110,  111,  112,  109,  111,
      112,   41,   84,  111,  112,   42,   84,  111,  112,   40,

       43,   84,  111,  112,   40,   84,  111,  112,   40,   44,
       84,  111,  112,   40,   84,  111,  112,   40,   45,   84,
      111,  112,   40,   84,  111,  112,   40,   46,   84,  111,
      112,   40,   47,   84,  111,  112,   40,   48,   84,  111,
      112,   40,   49,   84,  111,  112,   40,   50,   84,  111,
      112,   40,   51,   84,  111,  112,   40,   84,  111,  112,
       40,   84,  111,  112,   40,   84,  111,  112,   40,   84,
      111,  112,    1,  110,  111,  112,  109,  111,  112,   84,
      111,  112,   84,  111,  112,   84,  111,  112,   84,  111,
      112,   84,  111,  112,    1,  110,  111,  112,  109,  111,

      112,   84,  111,  112,    1,  110,  111,  112,  109,  111,
      112,   84,  111,  112,    1,  110,  111,  112,  109,  111,
      112,   84,  111,  112,   84,  111,  112,   84,  111,  112,
       84,  111,  112,   84,  111,  112,   84,  111,  112,   84,
      111,  112,   84,  111,  112,    1,  110,  111,  112,  109,
      111,  112,   84,  111,  112,   84,  111,  112,   84,  111,
      112,   84,  111,  112,    1,  110,  111,  112,  109,  111,
      112,   84,  111,  112,   84,  111,  112,   84,  111,  112,
       84,  111,  112,   84,  111,  112,   84,  111,  112,    1,
      110,  111,  112,  109,  111,  112,   84,  111,  112,    1,

      110,  111,  112,  109,  111,  112,    1,  110,  111,  112,
      109,  111,  112,    2,    3,  112,    2,    3,  111,  112,
        1,  110,  111,  112,  109,    3,   91,   94,   85,   92,
       89,   87,   88,  108,   90,   99,   95,   97,   93,  109,
        3,   84,   79,   81,   91,   94,  105,   81,   86,   92,
      107,   89,   87,   88,  108,   82,   90,  104,   82,   83,
       99,  100,  101,   95,  102,   98,   97,   73,   84,   84,
       72,   84,   84,   84,   84,   96,   98,  101,  100,   93,
      106,  109,  109,  108,  109,   84,   77,   32,  108,   82,
       82,   83,   84,   84,   73,   84,   84,    8,   84,   84,

       84,   84,   84,   84,   12,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   72,   84,   84,   84,   84,   84,   84,  109,  109,
       41,   42,   40,   43,   40,   40,   44,   40,   40,   45,
       40,   40,   46,   40,   47,   40,   48,   40,   49,   40,
       50,   40,   51,   40,   40,   40,   40,  109,   41,   84,
       40,   84,   42,   40,   43,   40,   43,   84,   40,   40,
       73,   84,   40,   44,   40,   44,   84,   40,   45,   40,
       45,   84,   40,   84,   40,   46,   40,   46,   84,   40,
       47,   40,   47,   84,   40,   48,   40,   48,   84,   40,

       48,   84,   40,   49,   40,   49,   84,   40,   50,   40,
       50,   84,   40,   51,   40,   51,   84,   40,   72,   84,
       40,   84,   40,   84,   40,   84,   40,   84,  109,  109,
      109,   84,   84,   84,   34,   84,   84,   84,  109,  109,
      109,   84,  109,  109,  109,   84,  109,  109,  109,   84,
       84,   84,   84,   84,   84,   84,   84,   84,  109,  109,
      109,   84,   84,   84,   84,   84,  109,  109,  109,   84,
       71,   73,   84,   84,   72,   84,   84,   84,   84,  109,
      109,  109,   84,  109,  109,  109,  109,  109,    2,    3,
      109,    2,    3,  109,   73,   72,   79,   81,   81,  105,

       81,   81,  107,  104,  100,  101,  102,   98,   73,   74,
       84,   72,   84,   84,   84,   98,   97,  101,  103,   99,
      100,  106,   73,    8,   12,   72,   77,   32,   84,    6,
       84,   73,   84,    8,   84,   84,   31,   84,   84,   74,
       84,   12,   84,   84,   84,   16,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   24,   84,   84,   84,   84,
       72,   84,   84,   84,   84,   84,   84,   40,   43,   40,
       73,   40,   44,   40,   45,   40,   40,   46,   40,   47,
       40,   48,   40,   48,   40,   49,   40,   50,   40,   51,
       40,   72,   40,   40,   40,   40,   40,   43,   84,   40,

       73,   40,   44,   84,   40,   45,   84,   40,   74,   84,
       40,   46,   84,   40,   47,   84,   40,   48,   84,   40,
       48,   84,   40,   49,   84,   40,   50,   84,   40,   51,
       84,   40,   72,   40,   84,   40,   84,   40,   84,   40,
       84,   34,   84,   84,   35,   84,   34,   84,   84,   84,
       84,   54,   84,   84,   84,   84,   84,   84,   84,   84,
       61,   84,   84,   84,   84,   74,   84,   84,   84,   73,
       72,   73,   74,   84,   72,   84,   84,   84,   84,   74,
       78,   80,   74,   84,   84,   64,   84,   97,  103,   99,
        6,   31,   74,   16,   24,   84,    6,    7,   84,    9,

       84,   10,   84,   31,   11,   84,   74,   84,   84,   84,
       16,   84,   84,   84,   84,   20,   84,   21,   84,   84,
       84,   24,   84,   84,   63,   84,   84,   84,   84,   29,
       84,   84,   64,   84,   40,   43,   40,   44,   40,   45,
       40,   74,   40,   46,   40,   47,   40,   48,   40,   48,
       40,   49,   40,   50,   40,   51,   40,   40,   40,   40,
       40,   44,   84,   40,   45,   84,   40,   74,   40,   46,
       84,   40,   47,   84,   40,   48,   84,   40,   48,   84,
       40,   50,   84,   40,   51,   84,   40,   84,   40,   84,
       40,   84,   40,   64,   84,   35,   37,   84,   84,   35,

       84,   84,   84,   84,   54,   61,   54,   84,   84,   84,
       56,   84,   84,   84,   84,   61,   84,   74,   84,   84,
       66,   84,   69,   84,   84,   74,   74,   84,   84,   84,
       64,   84,   63,   84,   64,   78,   76,   84,   75,   84,
       64,    7,    9,   10,   11,   20,   21,   63,   29,   64,
       84,    7,    9,   10,   11,   84,   84,   15,   84,   84,
       84,   18,   84,   84,   20,   21,   22,   84,   84,   84,
       84,   63,   27,   84,   76,   84,   28,   84,   29,   75,
       84,   64,   40,   44,   40,   45,   40,   46,   40,   47,
       40,   48,   40,   48,   40,   50,   40,   51,   40,   40,

       40,   40,   64,   40,   44,   84,   40,   45,   84,   40,
       46,   84,   40,   47,   84,   40,   48,   84,   40,   48,
       84,   40,   50,   84,   40,   76,   84,   33,   40,   84,
       40,   75,   84,   40,   64,   37,   37,   84,   84,   33,
       84,   36,   84,   84,   56,   84,   84,   84,   56,   84,
       53,   84,   62,   84,   84,   66,   69,   84,   84,   66,
       69,   84,   64,   84,   76,   84,   75,   84,   64,   63,
       63,   76,   75,   76,   75,   15,   18,   22,   27,   76,
       28,   75,   84,   84,   84,   15,   84,   84,   18,   84,
       22,   23,   84,   25,   84,   26,   84,   27,   76,   28,

       75,   40,   44,   40,   45,   40,   46,   40,   47,   40,
       48,   40,   48,   40,   50,   40,   76,   33,   40,   40,
       75,   40,   44,   84,   40,   45,   84,   40,   46,   84,
       40,   47,   84,   40,   48,   84,   40,   48,   84,   40,
       50,   84,   40,   76,   33,   40,   40,   75,   33,   84,
       39,   84,   33,   36,   36,   52,   84,   53,   62,   84,
       59,   84,   84,   57,   84,   53,   62,   84,   65,   84,
       84,   84,   76,   75,   84,   76,   75,   23,   25,   26,
        5,   84,   84,   14,   84,   17,   84,   84,   84,   23,
       25,   26,   40,   44,   40,   45,   40,   46,   40,   47,

       40,   48,   40,   48,   40,   50,   40,   44,   84,   40,
       46,   84,   40,   48,   84,   40,   50,   84,   39,   38,
       84,   39,   52,   52,   59,   57,   84,   59,   55,   84,
       57,   60,   84,   65,   65,   84,   84,   70,   84,    5,
       14,   17,    5,   84,   14,   17,   84,   84,   40,   44,
       40,   46,   40,   48,   40,   50,   40,   44,   84,   40,
       46,   84,   40,   48,   84,   38,   38,   55,   60,   58,
       84,   55,   60,   84,   84,   70,   70,   13,   84,   30,
       84,   19,   84,   40,   44,   40,   46,   40,   48,   40,
       46,   84,   58,   58,   84,   84,   13,   30,   19,   13,

       30,   19,   40,   46,   40,   46,   84,   84,   67,   84,
       40,   46,   40,   46,   84,   67,   68,   84,   67,   40,
       46,   40,   46,   84,   68,   68,   40,   46,   40,   46,
       84,   40,   46
    } ;

static const short int yy_accept[1184] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    5,    8,   10,   13,   15,   19,   22,   24,
       27,   30,   33,   36,   39,   42,   46,   49,   53,   55,
       58,   61,   65,   68,   71,   74,   77,   80,   83,   87,
       90,   93,   97,  101,  105,  109,  112,  117,  121,  124,
      128,  132,  136,  140,  144,  148,  153,  157,  162,  165,
      169,  173,  178,  182,  186,  190,  194,  198,  202,  207,
      211,  215,  220,  223,  226,  230,  234,  237,  240,  243,

      246,  249,  252,  255,  258,  261,  264,  267,  270,  273,
      276,  279,  282,  285,  289,  292,  296,  300,  305,  309,
      314,  318,  323,  327,  332,  337,  342,  347,  352,  357,
      361,  365,  369,  373,  377,  380,  383,  386,  389,  392,
      395,  399,  402,  405,  409,  412,  415,  419,  422,  425,
      428,  431,  434,  437,  440,  443,  446,  450,  453,  456,
      459,  462,  465,  469,  472,  475,  478,  481,  484,  487,
      490,  494,  497,  500,  504,  507,  511,  514,  517,  521,
      525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
      535,  536,  537,  538,  539,  539,  539,  539,  539,  539,

      539,  540,  541,  542,  543,  544,  544,  544,  544,  545,
      545,  546,  547,  548,  548,  548,  548,  549,  549,  550,
      551,  552,  553,  554,  555,  556,  557,  558,  559,  561,
      562,  563,  564,  565,  566,  567,  568,  570,  571,  573,
      574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
      583,  584,  584,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  586,  586,  587,  588,  589,  590,  591,  591,
      593,  594,  595,  597,  598,  600,  601,  602,  603,  604,
      605,  607,  608,  609,  610,  611,  612,  613,  614,  615,

      616,  617,  618,  619,  620,  621,  622,  624,  625,  626,
      627,  628,  629,  630,  630,  631,  632,  633,  635,  636,
      638,  639,  641,  642,  644,  646,  648,  650,  652,  654,
      655,  656,  657,  658,  659,  660,  661,  663,  664,  666,
      669,  670,  673,  675,  678,  680,  683,  685,  687,  690,
      692,  695,  697,  700,  703,  705,  708,  710,  713,  715,
      718,  721,  723,  725,  727,  729,  730,  730,  731,  731,
      731,  731,  731,  731,  732,  733,  734,  735,  737,  738,
      739,  740,  740,  741,  741,  742,  743,  744,  744,  745,
      745,  746,  747,  748,  748,  749,  749,  749,  749,  749,

      749,  749,  749,  749,  750,  751,  752,  753,  754,  755,
      756,  757,  758,  759,  760,  760,  761,  761,  761,  761,
      761,  762,  763,  764,  765,  766,  767,  768,  768,  769,
      769,  769,  769,  769,  769,  769,  770,  770,  771,  772,
      774,  775,  777,  778,  779,  780,  781,  781,  782,  782,
      783,  784,  785,  785,  786,  787,  788,  788,  789,  791,
      792,  794,  795,  795,  796,  796,  797,  797,  797,  797,
      797,  798,  799,  800,  800,  800,  800,  800,  800,  801,
      802,  803,  803,  803,  803,  803,  804,  805,  806,  807,
      808,  809,  810,  812,  813,  814,  815,  816,  817,  818,

      819,  820,  821,  822,  823,  823,  823,  823,  824,  824,
      825,  825,  825,  825,  825,  825,  826,  826,  826,  826,
      826,  826,  826,  826,  826,  826,  826,  826,  826,  826,
      826,  826,  827,  827,  827,  827,  827,  827,  828,  829,
      830,  832,  833,  834,  835,  836,  837,  839,  840,  842,
      843,  844,  845,  846,  848,  849,  850,  851,  852,  853,
      854,  855,  856,  858,  859,  860,  861,  862,  863,  864,
      865,  866,  867,  868,  868,  870,  872,  874,  876,  877,
      879,  881,  883,  885,  887,  889,  891,  893,  894,  895,
      896,  897,  900,  902,  905,  908,  911,  914,  917,  920,

      923,  926,  929,  932,  934,  936,  938,  940,  942,  942,
      942,  942,  943,  943,  943,  944,  945,  947,  948,  949,
      950,  950,  951,  951,  952,  952,  952,  952,  952,  952,
      952,  952,  952,  952,  954,  955,  956,  957,  958,  959,
      960,  961,  963,  964,  964,  964,  964,  964,  964,  965,
      966,  968,  969,  970,  970,  971,  971,  972,  972,  972,
      972,  973,  975,  976,  977,  978,  979,  979,  980,  981,
      981,  981,  981,  982,  983,  983,  983,  983,  983,  984,
      985,  986,  988,  989,  990,  991,  991,  992,  992,  992,
      992,  993,  993,  994,  994,  994,  994,  995,  995,  995,

      995,  995,  995,  995,  995,  995,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  997,  998, 1000, 1002,
     1004, 1005, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014,
     1015, 1016, 1018, 1020, 1021, 1022, 1023, 1024, 1025, 1027,
     1028, 1029, 1030, 1032, 1033, 1035, 1037, 1039, 1041, 1043,
     1045, 1047, 1049, 1051, 1053, 1055, 1057, 1058, 1059, 1060,
     1061, 1064, 1067, 1069, 1072, 1075, 1078, 1081, 1084, 1087,
     1089, 1091, 1093, 1096, 1096, 1096, 1097, 1097, 1097, 1099,
     1100, 1101, 1102, 1103, 1103, 1104, 1104, 1105, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1107, 1107, 1108, 1109,

     1110, 1111, 1113, 1114, 1115, 1116, 1117, 1118, 1118, 1118,
     1119, 1119, 1119, 1120, 1121, 1123, 1125, 1126, 1127, 1127,
     1127, 1127, 1128, 1129, 1130, 1131, 1133, 1133, 1135, 1135,
     1135, 1136, 1137, 1137, 1137, 1137, 1137, 1137, 1137, 1139,
     1141, 1142, 1142, 1143, 1144, 1145, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1147, 1148, 1148, 1148, 1148, 1148,
     1149, 1149, 1149, 1149, 1150, 1150, 1151, 1152, 1153, 1154,
     1155, 1156, 1157, 1158, 1160, 1161, 1162, 1164, 1165, 1166,
     1167, 1169, 1170, 1171, 1172, 1173, 1175, 1177, 1179, 1180,
     1182, 1183, 1185, 1187, 1189, 1191, 1193, 1195, 1197, 1199,

     1200, 1201, 1202, 1204, 1207, 1210, 1213, 1216, 1219, 1222,
     1225, 1228, 1231, 1234, 1236, 1237, 1237, 1237, 1237, 1238,
     1239, 1240, 1242, 1242, 1244, 1244, 1245, 1245, 1245, 1245,
     1246, 1246, 1246, 1246, 1246, 1247, 1248, 1249, 1250, 1251,
     1253, 1255, 1256, 1256, 1256, 1257, 1258, 1258, 1259, 1260,
     1261, 1262, 1263, 1263, 1263, 1263, 1264, 1265, 1267, 1269,
     1270, 1271, 1272, 1273, 1274, 1275, 1276, 1276, 1276, 1276,
     1277, 1277, 1277, 1278, 1278, 1279, 1279, 1279, 1279, 1280,
     1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290,
     1291, 1292, 1294, 1296, 1298, 1299, 1300, 1301, 1302, 1304,

     1306, 1308, 1310, 1312, 1314, 1316, 1318, 1320, 1322, 1325,
     1328, 1331, 1334, 1337, 1340, 1343, 1345, 1347, 1349, 1349,
     1349, 1350, 1351, 1353, 1354, 1355, 1356, 1356, 1358, 1358,
     1358, 1358, 1358, 1359, 1360, 1360, 1361, 1363, 1364, 1366,
     1367, 1368, 1369, 1369, 1369, 1369, 1371, 1372, 1373, 1373,
     1374, 1375, 1376, 1377, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1379, 1380, 1381, 1383, 1384, 1386, 1388, 1389, 1390,
     1391, 1392, 1393, 1395, 1397, 1399, 1401, 1403, 1405, 1407,
     1410, 1413, 1416, 1419, 1419, 1420, 1422, 1423, 1424, 1425,
     1425, 1426, 1426, 1427, 1427, 1428, 1429, 1431, 1432, 1434,

     1435, 1435, 1435, 1436, 1437, 1438, 1438, 1440, 1441, 1441,
     1442, 1443, 1443, 1443, 1444, 1445, 1446, 1447, 1448, 1449,
     1451, 1453, 1455, 1457, 1460, 1463, 1466, 1467, 1468, 1468,
     1469, 1470, 1472, 1473, 1474, 1474, 1474, 1475, 1476, 1477,
     1478, 1478, 1478, 1478, 1480, 1482, 1484, 1486, 1488, 1490,
     1493, 1494, 1495, 1495, 1495, 1496, 1497, 1498, 1499, 1500,
     1501, 1502, 1503, 1505, 1508, 1508, 1508, 1509, 1511, 1513,
     1516, 1516, 1517, 1519, 1520, 1522, 1525, 1526, 1527, 1529,
     1532, 1534, 1534
    } ;

static const YY_CHAR yy_ec[128] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    7,    8,    9,   10,   11,
       12,   13,   14,   15,   16,   17,   18,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   20,   21,   22,
       23,   24,   25,    7,   26,   27,   28,   29,   30,   31,
       32,   33,   34,   35,   35,   36,   37,   38,   39,   40,
       41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
        1,   51,    1,   52,    7,    1,   26,   27,   28,   29,

       30,   31,   32,   33,   34,   35,   35,   36,   37,   38,
       39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
       49,   50,    1,   53,    1,   54,    1
    } ;

static const YY_CHAR yy_meta[55] =
    {   0,
        1,    2,    1,    2,    3,    1,    4,    1,    1,    1,
        5,    1,    1,    1,    1,    1,    4,    1,    4,    6,
        1,    1,    7,    1,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        1,    1,    1,    2
    } ;

static const short int yy_base[1196] =
    {   0,
        0,    0,   54,    0,  108,    0,  162,    0,  215,  224,
      219,  220,  225,  229,  282,    0,    0,    0,    0,    0,
      262,  300,  354,    0,  228,  233,  234,  243,  296,  407,
     3659, 4598,  460,  240, 3640,  513,  299,  411,  566,  412,
     4598,  417,  425,  431,  432,  435,  436,  439, 4598,  440,
      497,  504,  527,  207,  229,  232,  214,  299,  532,  555,
      443,  455, 4598,    0, 3626,  619,  498,  521,  672,  520,
     4598,  533,  558,  559,  562,  578,  586,  599, 4598,  598,
      603,  613,  639,  264,  270,  284,  296,  304,  656,  661,
      652,  627,  725,  666,  778,  781,  782,  277,  582,  282,

      675,  306,  765,  542,  630,  474,  784,  577,  665,  786,
      679,  766,  389,  662,  835,  888,  941,  896,  910,  914,
      922,  929,  936,  968,  975,  980,  984,  994, 1000, 1010,
     1014, 1021, 1033,  902, 1053,  406,  303,  803,  449,  441,
      953, 1039,  209, 1054, 1072,  228, 1075, 1128,  223,  401,
      414,  554,  677,  499,  415,  816,  963, 1081,  580,  617,
      686,  623, 1069, 1181, 1086, 1102, 1116, 1234, 1237, 1146,
     1099, 1238,  786, 1242, 1113, 1247, 1250, 1254, 1257, 1260,
        0, 1261, 1264, 1265, 4598, 1268, 1274, 1275, 1281, 1285,
     1295, 1301, 1308, 1298, 3559, 3563, 3544, 3544,  313, 1334,

     1338,    0, 1305, 3566, 1339, 3560, 3555, 1390,  739, 1420,
     1343, 1344, 1359, 3527, 3473, 1471,  485, 1501, 1369, 1373,
     1374, 1377, 1378, 1381, 1398, 1399, 1438, 1403, 1458, 1410,
     1404, 1434, 1461, 1439, 1464, 1485, 1468,  779, 1469,  811,
      685,  885, 1502, 1512, 1536, 1539, 1492, 1515,    0, 1532,
        0, 1545, 1550, 1559, 1569,  868,  894,  310, 1546,  952,
     1105,  788, 1099, 1017, 1036,  880, 1133, 1576, 1003, 1538,
     1567,    0, 1610,  920, 1549, 1570, 1615, 1618, 1623, 1630,
      945,  979, 1624,  984, 1638, 1208, 1149, 1053, 1425, 1104,
     1644, 1322, 1615, 1308, 1325, 1123, 1449, 1345, 1623, 1618,

     1626, 1641, 1508, 1579, 1647, 1629, 1686, 1665, 1653, 1664,
     1671, 1667,    0, 1583,    0, 1712, 1716, 1720, 1706, 1725,
     1729, 1742, 1732, 1749, 1746, 1765, 1745, 1786, 1787, 1771,
     1790, 1807, 1816,    0, 1804, 1810,  514, 1825, 1828, 1832,
     1833, 1843, 1844, 1851, 1852, 1858,  869, 1855, 1869, 1865,
     1891, 1876,  898,  600, 1879, 1897, 1892, 1913, 1906, 1918,
     1935, 1143, 1336,  702, 1283,    0, 1912,    0, 3454, 3425,
      313, 3384, 3354,    0,  249,  587,  542, 1927,  633,  933,
        0, 1930, 1938, 3330, 1945,  812, 1957, 1960, 1967, 3308,
     1974,  952, 1975, 1978,    0, 3279, 3248, 3261, 3246, 3244,

     3249,  652,  462,    0,  967, 1078,  676, 1105, 1083,  788,
     1161, 1419, 1089,    0, 1981,    0, 3222, 3216,  251, 3225,
        0, 1312, 1357, 1103, 1020, 1016,    0, 1984,    0, 1989,
     1992, 2014, 2021, 1996, 2022,    0, 2029, 1411, 4598, 2038,
     1921, 2045, 1969, 1476, 1973,    0, 2055, 2059,  964, 2060,
     1465, 2063, 2078, 2082, 2083, 2087, 2092,    0, 2086,    0,
     2091,    0, 2096, 2104, 3207, 2108, 3181, 3183, 3107, 2145,
     2116,  235, 1732, 2117,    0,    0, 2147,    0, 2140, 1664,
     2063, 2150,    0, 2153,    0, 2151, 2157, 2161, 2183, 2184,
     2187, 2188, 2191, 2194, 1087, 1244, 1273, 2199, 2204, 2205,

     2208, 2212, 2216, 2215, 1535, 1670, 2073, 2221, 1690, 2222,
     2192, 2201, 1710, 2097, 1809, 2231, 2223, 1980, 2101, 2207,
     2242, 2239, 2106, 2248, 2253, 2262, 2257, 2251, 2269, 2265,
     2273, 2304, 2171, 2280, 2281, 2283, 2285, 2314, 2324, 2232,
     2328, 2332, 2302, 2333, 2319, 2312, 2343, 2320, 2361, 2369,
     2337, 2346, 2352, 2372, 2354, 2370, 2362, 2378, 2366, 2380,
     2382, 2387, 2415, 2401, 2396, 2399, 2431, 2411, 2413, 2416,
     2421, 2420, 2419, 2462, 3109, 2466, 2469, 2472, 2444, 2477,
     2488, 2450, 1763, 2491, 2492, 2507, 2496, 2090, 2221, 1669,
     2306, 2515, 2497, 2534, 2535, 2551, 2552, 2555, 2458, 2473,

     2556, 2562, 2573, 2568, 1724, 2036, 2563, 1729, 3091, 3077,
     3068, 2574, 3028, 3020, 1393,  698, 2613, 2596, 1537, 1315,
     2992, 1896, 2987, 1962, 2952, 2939, 2883, 2866, 2863, 2787,
     2764, 1348, 2758, 2619, 1586, 1724, 1787, 1959, 1502, 2009,
     1384, 2627,  413, 2730, 2723, 2699, 2687, 2682, 2043, 2309,
     2631, 1813, 2086, 2616, 2630, 2641, 2642, 2653, 2652, 2656,
     2657, 2685, 2667, 1841, 2615, 1856, 2662, 1625, 2670, 2654,
     2630, 2629, 2689, 4598, 2701, 2740, 2721, 2768, 2699, 2382,
     2461, 2731, 2700, 2710, 2732, 2505, 2759, 2551, 2716, 2584,
     2773, 2747, 2777, 2763, 2680, 2761, 2780, 2781, 2787, 2731,

     2796, 2797, 2684, 2799, 2801, 2816, 2806, 2811, 2813, 2831,
     2823, 2832, 2825, 2835, 2779, 2839, 2874, 2878, 2881, 2882,
     2885, 2888, 2889, 2808, 2846, 2871, 2902, 2837, 2873, 2889,
     2904, 2912, 2936, 2915, 2908, 2947, 2919, 2926, 2956, 2933,
     2935, 2930, 2977, 2944, 2978, 2583, 2985, 2989, 2990, 2993,
     3000, 2970, 2975, 3009, 3013, 3014, 2496, 2507, 2862, 2529,
     3031, 3036, 3044, 3049, 3071, 3032, 3054, 3070, 3057, 2893,
     2607, 3080, 3084, 2540, 2547, 3075, 2474, 2462, 3090, 2568,
     3093, 1900, 2514, 2465, 2016, 2436, 1596, 3117, 2435, 2406,
     2391, 2344, 2327, 2248, 2201, 3118, 2197, 3124, 2114, 2449,

     2277, 3128,  880, 2636, 2572, 3129, 2746, 2198, 2130, 3132,
     2110, 2071, 1828, 2245, 3138, 3139, 2614, 3133, 3150, 3144,
     3156, 3151, 3131, 3161, 3082, 3157, 2028, 3164, 2012, 2000,
     3197, 3198, 3202, 3208, 3236, 3242, 3255, 3271, 3239, 3276,
     3222, 3178, 3275, 3290, 3304, 3305, 2995, 3216, 3218, 3013,
     3060, 3281, 3283, 3312, 3320, 3297, 3128, 3308, 3289, 3336,
     3313, 3167, 3215, 3359, 3322, 3365, 3328, 3373, 3377, 3382,
     3383, 3369, 3347, 3406, 3370, 3306, 3412, 3331, 3419, 3420,
     3416, 3388, 3405, 3396, 3442, 3448, 3449, 3453, 3465, 3457,
     3477, 3490, 3485, 3504, 3511, 3454, 3475, 3516, 3520, 3180,

     3189, 3438, 3521, 3526, 3508, 3534, 3551, 2969, 3533, 3574,
     3577, 3585, 3591, 3546, 3588, 1922, 1924, 1783, 3594, 1786,
     1893, 3595, 1735, 3599, 1716, 2652, 1688, 1689, 1645, 3607,
     1653, 1609, 1601, 1561, 2727, 3070, 2942, 3610, 2958, 3615,
     3618, 2597, 1547, 1545, 3621, 3630, 1483, 1910, 3030, 3631,
     3634, 2366, 3648, 3642, 3653, 3639, 3499, 3656, 3664, 3677,
     3652, 3678, 3697, 3701, 3707, 3710, 3386, 3675, 3679, 3718,
     3475, 3544, 3723, 3353, 3724, 3695, 3700, 3707, 3744, 3752,
     3755, 3766, 3644, 3434, 3733, 3765, 3751, 3716, 3787, 3745,
     3798, 3797, 3801, 3811, 3812, 3825, 3834, 3840, 3820, 3857,

     3845, 3860, 3515, 3795, 3865, 3866, 3869, 3874, 3883, 3887,
     3888, 3904, 3885, 1503, 3931, 3882, 3893, 3928, 1441, 1377,
     3936, 3151, 3942, 3946, 3947, 3950, 1385, 3953, 1373, 1361,
     1299, 1268, 3958, 3961, 1256, 2025, 3964, 2666, 3965, 3969,
     3975, 3177, 1247, 1213, 1093, 3976, 3445, 3294, 3979, 3982,
     3987, 3501, 3990, 3991, 3974, 3598, 3969, 3754, 3887, 3979,
     4018, 4023, 4024, 4033, 4009, 4038, 4044, 4014, 3775, 4059,
     4079, 4086, 4067, 4072, 4087, 4091, 4055, 2321, 4103, 4108,
     4114, 2669, 4120, 1050, 4030, 4126, 4066, 4127, 4130,  925,
     4150,  866, 4154,  807, 2687, 4159, 4162, 4163, 4167, 4168,

      801,  757, 4173, 2772, 1150, 4183, 4186, 4189, 4106, 4194,
     4197, 4160, 3804, 4210, 4150, 4230, 4240, 4153, 4199, 4243,
     4252, 2817, 4253, 4257, 4265, 3146, 4264, 4268,  752, 4269,
     4272, 4281, 4273, 4276,  739,  552, 3334, 3636, 4289, 4298,
     4261, 4286, 4295, 4327, 4330, 4334, 4306, 4337, 3353, 4344,
     4343, 4347,  535,  511, 3681, 3292, 4351, 4360, 4375, 4383,
     4388, 4392, 4405, 4414,  442,  442, 1810, 4417, 4418, 4421,
      309, 4422, 4428, 4431, 4434, 4448, 4441, 4445, 4453, 4475,
     4461, 4598, 4527, 4532, 4539, 4545, 4549, 4555, 4560, 4564,
     4570, 4576, 4581, 4583, 4590

    } ;

static const short int yy_def[1196] =
    {   0,
     1182,    1, 1182,    3, 1182,    5, 1182,    7,    1,    1,
        1,    1,    1,    1,    1,   15,    1,    1,    1,    1,
        1,    1, 1182,   23,    1,    1,    1,    1,    1,    1,
     1182, 1182, 1182, 1182, 1183, 1184, 1182, 1182, 1185, 1182,
     1182, 1182, 1182, 1182, 1182, 1186, 1182, 1186, 1182, 1182,
     1182, 1182, 1182, 1183, 1183, 1183, 1183, 1183, 1182, 1182,
     1182,   33, 1182,   33, 1183, 1184, 1182, 1182, 1185, 1182,
     1182, 1182, 1182, 1182, 1182, 1186, 1182, 1186, 1182, 1182,
     1182, 1182, 1182, 1183, 1183, 1183, 1183, 1183, 1182, 1182,
     1182,   33, 1182, 1187, 1188, 1188, 1187,   97,   97,   97,

       97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
       97,   97,   97,   93, 1182, 1189, 1189,  117,  117,  117,
      117,  117,  117,  117,  117,  117,  117,  126,  126,  126,
      126,  126,  126,  115,   33, 1183, 1183, 1183, 1183, 1183,
      135,   33, 1183,   33,   33, 1183,   33,   33, 1183, 1183,
     1183, 1183, 1183, 1183, 1183, 1183,  148,   33, 1183, 1183,
     1183, 1183,  158, 1182, 1190, 1190, 1190, 1190, 1190, 1190,
      164,   33, 1183,   33,   33,   33,   33, 1182, 1182,  177,
       33, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,

     1182,   33, 1182, 1183, 1182, 1184,   66,   66, 1182,   66,
     1182, 1182, 1182, 1185,   69,   69, 1182,   69, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1186, 1182, 1182, 1186, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1183, 1183, 1183, 1183,
     1183, 1183, 1182, 1182, 1182, 1182, 1182, 1182,   33,   33,
       93, 1191, 1192, 1192, 1191,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,   93, 1182,   97, 1182, 1182, 1182, 1188, 1182, 1188,
       97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
       97,   97,   97,   97,   97,   97,   97,   97,   97,   97,

       97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
       97,   97,   93,   93,  115, 1193, 1193, 1193,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  115, 1182,  117,  133, 1182, 1182,  133,
     1182,  133, 1182,  133, 1182,  133,  133, 1182,  133, 1182,
      133, 1182,  126,  126, 1182,  126, 1182,  126, 1182,  126,
      126,  133,  133,  133,  133,  115,  115,  135, 1182, 1182,
     1182, 1182, 1182,  135, 1183, 1183, 1183, 1183, 1183, 1183,
      135,  135,   33, 1182,   33, 1183,   33,   33,   33, 1182,
       33, 1183,   33,   33,  148, 1182, 1182, 1182, 1182, 1182,

     1182, 1182, 1182,  148, 1183, 1183, 1183, 1183, 1183, 1183,
     1183, 1183, 1183,  148,  148,  158, 1182, 1182, 1182, 1182,
      158, 1183, 1183, 1183, 1183, 1183,  158,  158,  164, 1194,
     1194, 1194, 1194, 1194, 1194,  164, 1182,  170, 1182,  170,
      170,  170,  170,  170,  170,  164,  164,   33, 1182,   33,
     1183,   33,   33,   33,   33,   33,   33,  177, 1182,  177,
     1182,  177,  177, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182,  210,  210, 1195,  210,  210, 1182, 1182,
     1182,  218,  218,  218,  218, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1183, 1182, 1183, 1183, 1183, 1182, 1182, 1182,

     1182, 1182, 1182, 1182,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255, 1182, 1182,   97,
       97, 1182,   97, 1182,   97,   97,   97,   97,   97, 1182,
       97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
       97,   97,   97,   97,   97,   97, 1182,   97,   97,   97,
       97,   97,   97, 1193,  318,  318,  318,  318,  333,  318,
      318,  326,  326,  318,  318,  318,  318,  333,  333,  333,
      333,  133, 1182,  133,  126,  126,  126,  126,  126,  126,

      126,  126,  126, 1182,  133,  133,  133,  133, 1182, 1182,
     1182, 1182, 1182, 1182, 1183, 1183, 1183, 1182, 1183, 1183,
     1182, 1183, 1182, 1183, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1183, 1183, 1183, 1183, 1183, 1183, 1183,
     1183, 1183, 1183, 1182, 1182, 1182, 1182, 1182, 1183, 1183,
     1183, 1183, 1183, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1182,  170, 1182,  170,  170,  170, 1182, 1183, 1182, 1182,
     1182, 1182, 1182, 1182,  210, 1184,  218, 1185, 1182, 1183,
     1183, 1183, 1182, 1182, 1182,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,

      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,   97, 1182,   97,   97,   97,
     1182,   97, 1182,   97,   97,   97, 1182,   97,   97,   97,
       97,   97,   97,   97,   97, 1182,   97,   97,   97,   97,
       97,   97,   97,   97,   97,  318,  318,  318,  318,  318,
      318,  326,  326,  318,  318,  318,  333,  333,  333,  333,
      133,  133, 1182,  133,  133,  126,  126,  126,  126,  133,
      133,  133,  133, 1182, 1182, 1182, 1182, 1182, 1183, 1183,
     1182, 1183, 1183, 1182, 1183, 1182, 1183, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1183, 1183,

     1183, 1183, 1183, 1183, 1183, 1182, 1183, 1182, 1182, 1182,
     1182, 1182, 1183, 1183, 1183, 1183, 1183, 1194, 1194, 1194,
     1194, 1182,  170,  170,  170,  170, 1182, 1183, 1182, 1182,
     1182, 1182,  210,  210,  210,  218,  218,  218, 1183, 1183,
     1182,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,   97, 1182, 1182, 1182,
     1182,   97,   97,   97,   97,   97,   97,   97, 1182, 1182,
       97,   97,   97,   97, 1182,   97,   97,   97, 1182,   97,
     1182,  318,  318,  318,  318,  326,  326,  318,  318,  333,

      333,  333,  318,  133,  133,  133,  133,  126,  126,  126,
      126,  126,  126, 1182, 1182, 1182, 1182, 1182, 1182, 1183,
     1183, 1183, 1182, 1183, 1182, 1183, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1183, 1183, 1183, 1182, 1183, 1183,
     1183, 1183, 1182, 1182, 1182, 1182, 1182, 1183, 1183, 1182,
     1182, 1183, 1194, 1194, 1194, 1194,  170,  170,  170, 1182,
     1182, 1182, 1182, 1182, 1182, 1182,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,   97,   97,   97, 1182,   97,   97, 1182,   97,
     1182,   97,   97,   97, 1182, 1182, 1182, 1182,  318,  318,

      318,  318,  326,  326,  318,  318,  318,  318,  126,  126,
      126,  126,  126,  126,  126, 1182, 1182, 1182, 1182, 1182,
     1182, 1183, 1183, 1182, 1182, 1182, 1182, 1183, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1183, 1183, 1183, 1183, 1182,
     1182, 1183, 1182, 1182, 1182, 1183, 1183, 1183, 1194, 1194,
     1194,  170, 1182, 1182,  255,  255,  255,  255,  255,  255,
      255,  255,  255,   97,   97,   97,   97,   97,   97, 1182,
     1182, 1182,  318,  318,  318,  318,  326,  326,  318,  126,
      126,  126,  126, 1182, 1182, 1183, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1183, 1182, 1183, 1182, 1183, 1182,

     1182, 1182, 1182, 1183, 1183, 1194,  170,  255,  255,  255,
      255,  255,  255, 1182,   97, 1182, 1182,   97,   97,  318,
      318,  326,  318,  126,  133,  126, 1182, 1182, 1182, 1182,
     1182, 1183, 1182, 1182, 1182, 1182, 1183, 1183, 1194, 1182,
      255,  255,  255,   97,   97,   97,  318,  318,  326,  126,
     1182, 1182, 1182, 1182, 1183, 1183,  255,  255,  255, 1182,
     1182, 1182,  318,  126, 1182, 1182, 1183, 1183,  318,  126,
     1182, 1182, 1183, 1182,  318,  126, 1182, 1182,  318,  126,
      318,    0, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182

    } ;

static const short int yy_nxt[4653] =
    {   0,
       32,   33,   34,   33,   35,   36,   35,   37,   38,   39,
       40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
       50,   51,   52,   53,   35,   35,   54,   35,   35,   35,
       55,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   56,   57,   35,   58,   35,   35,   35,
       59,   60,   61,   62,   63,   64,   34,   64,   65,   66,
       65,   67,   68,   69,   70,   71,   72,   73,   74,   75,
       76,   77,   78,   79,   80,   81,   82,   83,   65,   65,
       84,   65,   65,   65,   85,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   86,   87,   65,

       88,   65,   65,   65,   89,   90,   91,   92,   32,   93,
       34,   93,   94,   36,   94,   37,   38,   39,   40,   41,
       42,   43,   44,   45,   95,   47,   96,   49,   50,   51,
       52,   53,   94,   97,   98,   99,  100,  101,  102,   94,
       94,  103,   94,  104,   94,  105,  106,  107,  108,  109,
      110,  111,  112,   94,  113,   94,   94,   94,   59,   60,
       61,  114,   32,  115,   34,  115,  116,   36,   35,   37,
       38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
       48,   49,   50,   51,   52,   53,  117,  118,  119,  120,
      121,  122,  123,  121,  121,  124,  121,  125,  121,  126,

      127,  121,  121,  128,  129,  130,  131,  132,  133,  121,
      121,  121,   59,   60,   61,  134,  135,  205,  135,  205,
      142,  142,  142,  142,  205,  135,  145,  135,  145,  172,
      145,  172,  145,  205,  172,  175,  172,  175,  205,  205,
      206,  203,  205,  203,  175,  673,  175,  136,  143,  143,
      386,  240,  137,  138,  146,  237,  136,  139,  146,  205,
      140,  137,  138,  158,  405,  158,  139,  238,  141,  140,
      239,  173,  144,  144,  205,  392,  173,  141,  147,  140,
      205,  174,  147,  148,  615,  148,  174,  176,  140,  646,
      159,  160,  161,  203,  205,  647,  176,  177,  178,  177,

      211,  158,  211,  158,  162,  274,  205,  149,  238,  205,
      274,  150,  237,  205,  205,  163,  179,  151,  274,  152,
      285,  153,  239,  286,  154,  283,  155,  156,  159,  160,
      161,  241,  242,  240,  274,  157,  241,  242,  505,  173,
     1177,  376,  162,  611,  290,  468,  469,  274,  510,  180,
      612,  511,  211,  163,   32,  164,   34,  164,  165,   36,
      165,   37,   38,   39,   40,   41,   42,   43,   44,   45,
       46,   47,   48,   49,   50,   51,   52,   53,  165,  165,
      166,  165,  165,  165,  167,  165,  165,  165,  165,  165,
      165,  165,  165,  165,  165,  165,  165,  168,  169,  165,

      170,  165,  165,  165,   59,   60,   61,  171,  177,  178,
      177,  205,  212,  219,  212,  219,  205,  274,  220,  213,
      220,  311,  312,  205,  205,  205,  222,  179,  222,  221,
      274,  375,  223,  224,  223,  224,  225,  227,  225,  227,
     1182,  203, 1182,  203,  247,  205,  247,  407,  406,  205,
      173,  205,  240,  228,  411,  807,  249,  229,  249,  205,
      180,  181,  182,  181,  212,  219,  380,  183,  184, 1172,
      220,  185,  186,  187,  188,  189,  190,  191,  222, 1171,
      182,  192,  193,  194,  223,  224,  195,  632,  225,  227,
      196,  633, 1182,  203,  214,  248,  247,  379,  230,  211,

      230,  211,  274,  197,  198,  233,  199,  233,  250,  205,
      200,  200,  201,  202,  207,  274,  208,  297,  209,  231,
      232,  219,  212,  219,  212,  231,  234,  235,  236,  213,
      236,  210,  476,  243,  220,  243,  220,  410,  210,  210,
      210,  210,  210,  210, 1166,  221,  337,  337,  232,  235,
      230,  211,  205,  244,  245,  246,  243,  233,  243,  222,
      223,  222,  223,  224,  205,  224,  207,  215, 1165,  216,
      274,  294,  617,  219,  212,  217,  244,  245,  246,  225,
      236,  225, 1154,  274,  218,  243,  220,  227,  205,  227,
      205,  218,  218,  218,  218,  218,  218,  205,  408,  203,

     1182,  203, 1182,  228,  230,  274,  230,  284,  243,  205,
      274,  222,  223,  422,  233,  224,  233,  229,  274,  215,
      207,  301,  208,  274,  209,  231,  232,  205,  249,  337,
      249,  225,  616,  205,  231,  234,  235,  210,  337,  227,
      236,  600,  236,  205,  210,  210,  210,  210,  210,  210,
      426,  203, 1182,  247,  423,  247,  230,  243,  274,  243,
      232,  235,  243,  313,  243,  313,  233,  273,  295,  273,
      619,  274,  207,  215,  296,  216,  205,  244,  245,  246,
      250,  217,  244,  245,  246,  275,  205,  205,  276,  467,
      218,  631,  236,  274,  302,  205,  205,  218,  218,  218,

      218,  218,  218,  274,  248,  247,  274,  274,  205,  243,
      287,  306,  288,  636,  243,  314,  274,  307,  496,  273,
      308,  409,  289,  780,  424,  215,  251,  182,  251,  252,
      425,  252,  183,  184,  337,  607,  185,  186,  187,  188,
      189,  253,  191,  254,  206,  182,  192,  193,  194,  252,
      255,  256,  257,  258,  259,  260,  252,  252,  261,  252,
      262,  252,  263,  264,  265,  266,  267,  268,  269,  270,
      252,  271,  252,  252,  252,  200,  200,  201,  272,  277,
     1153,  277,  279,  273,  279,  273,  476, 1151,  205,  205,
     1136,  205,  205,  274,  274,  291,  205,  275,  205,  280,

      275,  275,  292,  309,  276,  310,  274,  274,  293,  298,
      281,  303,  274,  205,  274,  304,  505,  519,  451,  305,
      493,  205,  205,  282,  239,  299,  205,  274,  300,  505,
     1135,  277,  639,  377,  279,  273,  315,  182,  315,  316,
      378,  412,  183,  184, 1131,  413,  185,  186,  187,  188,
      189,  190,  191,  622,  495,  182,  192,  193,  194,  317,
      318,  319,  320,  321,  322,  323,  321,  321,  324,  321,
      325,  321,  326,  327,  321,  321,  328,  329,  330,  331,
      332,  333,  321,  321,  321,  200,  200,  201,  334,  335,
      205,  335,  336, 1130,  204,  205,  505,  339,  205,  339,

      204,  337,  337,  366,  204,  366,  204,  939,  505,  505,
      596,  341,  336,  341,  204,  343,  508,  343,  204,  509,
      204,  505,  505,  341,  526,  341,  204,  337,  497,  599,
      345,  340,  345,  204,  204,  505,  337,  341,  204,  341,
      204,  335,  338,  205,  338,  336,  204,  204,  274,  339,
     1129,  205,  344,  204,  381,  367,  381,  204,  342,  204,
      204,  274,  205,  341,  414,  336,  414,  343,  620,  348,
      346,  348,  204,  540,  347,  341,  350,  205,  350,  204,
      505,  352,  345,  352,  204,  355,  274,  355,  204,  341,
      515,  624,  204,  505,  338,  357,  667,  357,  634,  204,

      351,  359,  466,  359,  204,  349,  382,  274,  204,  353,
      541,  341,  274,  341,  356,  341,  415,  341,  354,  543,
      274,  348,  341,  358,  341,  274,  205,  360,  350,  337,
      205,  505,  337,  352,  341,  531,  341,  355,  337,  337,
      383,  532,  383,  337,  533,  505,  363,  357,  361,  653,
      337,  362,  337,  359,  368,  387,  368,  387,  505,  337,
      522,  523,  337,  341,  505,  364,  365,  341,  384,  652,
      427,  337,  427,  389,  341,  389,  393,  524,  393, 1127,
      525,  547,  416,  384,  416,  369,  341,  437,  205,  437,
      370,  371,  385,  205,  274,  372,  205,  205,  373,  205,

      446,  390,  446,  437,  390,  437,  374,  388,  439,  417,
      418,  419,  205,  205,  454,  205,  454,  437,  638,  437,
      680,  635,  428,  420,  439,  391,  205,  505,  394,  395,
      643,  395,  274,  505,  421,  516, 1102,  520,  439,  437,
      505,  637,  517,  521,  651,  549,  505,  437,  518,  437,
      440,  274,  447,  396,  441,  437,  205,  397,  373,  555,
      205,  505,  527,  398,  274,  399,  455,  400,  439,  437,
      401,  205,  402,  403,  505,  337,  337,  274,  444,  445,
     1138,  404,  429,  182,  429,  430,  605,  430,  183,  184,
      274,  546,  185,  186,  187,  188,  189,  190,  191,  437,

      640,  182,  192,  193,  194,  430,  430,  431,  430,  430,
      430,  432,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  433,  434,  430,  435,  430,  430,
      430,  200,  200,  201,  436,  437,  274,  437,  437,  448,
      437,  448, 1101,  452,  205,  452,  545,  205,  456,  274,
      456,  458,  459,  458,  205,  461,  439,  461,  461,  439,
      461,  462,  203,  462,  203,  211,  212,  211,  212,  220,
      459,  220,  442,  213,  443,  222,  223,  222,  223,  681,
      221,  449,  224,  205,  224,  449,  225,  437,  225, 1100,
      437,  450,  373,  449, 1094,  453,  227, 1093,  227,  236,

      457,  236,  230,  460,  230,  682,  203,  461,  203,  233,
      461,  233,  228,  463,  203,  337,  337,  211,  212,  232,
      235,  220,  205,  231,  232,  205,  608,  222,  223,  231,
      234,  235, 1092,  553,  224,  470,  274,  470,  225,  247,
      471,  247,  471,  649,  211,  212,  211,  212,  227,  274,
      274,  236,  213,  274,  230,  244,  245,  246,  203,  783,
      479,  233,  479,  274,  554,  551,  274,  205,  337,  337,
      219,  606,  219,  274,  220,  486,  220,  486,  222,  223,
      222,  223,  224,  795,  224,  221,  557,  470,  650,  796,
      248,  247,  471,  474,  205,  473,  211,  212, 1091,  225,

     1182,  225, 1182,  205,  487,  488,  487,  488,  475,  205,
     1090,  230,  479,  230, 1088,  475,  475,  475,  475,  475,
      475,  477,  219,  478, 1085,  473,  220,  486,  805,  205,
      222,  223,  231,  232,  224,  489,  779,  489,  475,  227,
      490,  227,  490,  438,  438,  475,  475,  475,  475,  475,
      475,  225, 1182,  274,  641,  228,  487,  488,  548, 1182,
      642, 1182,  233,  230,  233,  491,  274,  491,  205,  492,
      494,  492,  494,  477,  482,  205,  229,  274,  205,  205,
      481,  556,  231,  234,  235, 1084,  236,  489,  236,  483,
      274,  227,  490,  247,  668,  247,  483,  483,  483,  483,

      483,  483,  484,  243,  485,  243,  232,  235,  438,  665,
      481, 1182,  205,  498,  233,  498,  504,  491,  504,  483,
     1045,  492,  494,  244,  245,  246,  483,  483,  483,  483,
      483,  483,  337,  249,  499,  249,  274,  500,  236,  500,
      503,  337,  503,  803,  248,  247,  273,  205,  273,  274,
      538,  277,  538,  277,  484,  243,  563,  499,  501,  502,
      279,  502,  279,  505,  275,  498,  505,  276,  504,  275,
      273,  539,  273,  539,  505,  534,  505,  535,  275,  505,
      782,  512, 1044,  513,  313,  250,  313,  505,  275,  500,
     1043,  276,  503,  514, 1035,  505,  205,  506,  273,  536,

      537,  528,  538,  277,  505,  529,  205,  274,  505,  530,
      507,  273,  279,  273,  564,  799,  277,  505,  277,  279,
      274,  279,  273,  539,  279,  542,  279,  542,  205,  275,
     1034,  279,  276,  279,  275,  205,  314,  275,  926,  544,
      205,  544,  275,  274,  552,  550,  274,  550,  280,  275,
     1033,  274,  274,  559,  274,  561,  274,  274,  566,  274,
      560,  558,  828,  273,  274,  274,  274,  274,  277,  274,
      274,  279,  274,  214,  673,  274,  279,  542,  565,  274,
     1032,  274,  274,  279,  562,  274, 1031,  567,  274,  567,
      568,  544,  274,  274,  274,  274,  569,  550,  686,  274,

      571,  321,  759,  570,  572,  274,  274,  341,  274,  341,
      573,  505,  274,  335,  274,  335,  574,  338,  505,  338,
      574,  339, 1030,  339, 1182,  688,  343,  274,  343, 1029,
      341,  505,  341,  341,  205,  341,  574,  206,  691,  567,
      574,  321,  673,  345, 1182,  345,  355,  350,  355,  350,
      348,  505,  348,  800,  576,  575,  337,  770, 1027,  341,
      321,  773,  337,  577,  321,  335,  352,  321,  352,  338,
      579,  581,  341,  339,  341,  584, 1025,  321,  343,  476,
      321,  321,  341,  578,  321,  341,  580,  357,  359,  357,
      359,  341,  321,  341,  582,  345,  205,  205,  355,  350,

      321,  321,  348,  583,  753,  335,  321,  335,  341,  587,
      341, 1182, 1021, 1182,  586,  585,  801,  341,  352,  341,
      205,  321,  321,  205,  341,  321,  338,  588,  338,  339,
     1022,  339,  589,  339,  341,  339,  341,  505,  205,  357,
      359, 1173,  321,  341,  593,  343,  593,  343,  590,  591,
      693,  321,  343,  345,  343,  345,  348,  335,  348,  345,
      341,  345,  816, 1182,  337,  337,  350,  592,  350,  341,
      348,  948,  348,  438,  824,  337,  337,  352,  338,  352,
      355,  339,  355,  337,  337,  339,  341,  594,  826,  438,
      337,  337,  350,  357,  350,  357,  593,  343,  355,  595,

      355,  337,  337,  205,  343,  345,  205,  359,  348,  359,
      205,  345,  597,  366,  357,  366,  357,  598,  350,  359,
      205,  359,  348,  337,  337,  921,  337,  601,  618,  352,
      618,  381,  355,  381,  785,  337,  604,  205,  604,  383,
     1023,  383,  337,  603,  350,  357,  383,  337,  383, 1020,
      355,  337, 1046,  438,  438,  602,  337, 1019,  383,  359,
      383,  387,  662,  387,  337,  367,  357,  384,  389,  205,
      389,  359,  205,  337,  384,  389,  389,  389,  389,  393,
      618,  393,  414,  382,  414,  427,  384,  427,  604,  384,
      437,  385,  437,  437,  802,  437,  390,  437,  385,  437,

      787,  438,  438,  390,  390,  438,  438,  390,  505,  695,
      385,  439,  664,  388,  439,  437,  666,  437,  439,  205,
      391,  505,  437,  437,  437,  437,  205,  391,  391,  964,
      437,  394,  437,  658,  415,  205,  439,  428,  804,  661,
      655,  661,  437,  439,  439,  437,  663,  963,  663,  437,
     1095,  439,  656,  205,  659,  660,  446,  924,  446,  657,
      448,  448,  448,  448,  448,  961,  448,  437,  337,  337,
      438,  438,  214,  673,  437,  437,  813,  438,  438,  452,
      771,  452,  437,  454,  454,  454,  454,  461,  454,  461,
      454,  661,  461,  456,  461,  456,  205,  462,  663,  462,

      947,  505,  449,  449,  687,  492,  449,  492,  447,  494,
      476,  494,  450,  450,  505,  817,  450,  471,  207,  471,
      474,  449,  321,  321,  205,  505,  696,  373,  373,  505,
      692,  453,  373,  757,  505,  455,  455,  373,  505,  461,
      455,  479,  505,  479,  461,  457,  470,  700,  470,  463,
      675,  215,  486,  482,  486,  935,  677,  492,  487,  946,
      487,  494,  488,  944,  488,  676,  244,  245,  246,  471,
      207,  678,  676,  676,  676,  676,  676,  676,  678,  678,
      678,  678,  678,  678,  489,  490,  489,  490,  491,  492,
      491,  492,  679,  479,  679,  494,  710,  494,  470,  505,

      498,  205,  498,  215,  486,  683,  500,  683,  500,  684,
      487,  684,  505,  685,  488,  685,  504,  503,  504,  503,
      505,  499,  542,  544,  542,  544,  499,  501,  502,  505,
      689,  943,  550,  505,  550,  505,  489,  490,  502,  934,
      491,  492,  505,  690,  679,  933,  697,  494,  505,  505,
      505,  505,  498,  321,  321,  205,  758,  683,  500,  505,
      274,  684,  505,  505,  505,  685,  694,  505,  504,  503,
      505,  699,  505,  716,  542,  544,  505,  932,  698,  505,
      505,  505,  949,  505,  550,  505,  701,  205,  702,  505,
      505,  704,  505,  505,  505,  703,  708,  505,  505,  706,

      705,  505,  709,  505,  707,  567,  505,  567,  505,  505,
      505,  505,  713,  505,  505,  538,  714,  538,  937,  205,
      712,  505,  505,  711,  505,  539,  505,  539,  715,  717,
      274,  717,  505,  542,  544,  542,  544,  718,  321,  321,
      274,  720,  814,  274,  721,  505,  721,  274,  274,  760,
      321,  275,  275,  274,  276,  276,  274,  567,  719,  321,
      274,  274,  723,  722,  723,  274,  724,  538,  931,  274,
      550,  274,  550,  727,  274,  727,  205,  539,  274,  930,
      274,  717,  274,  728,  274,  542,  544,  725,  275,  274,
      274,  276,  205,  274,  274,  274,  721,  726,  274,  729,

      274,  732,  274,  274,  730,  731,  274,  274,  274, 1048,
      274,  274,  733,  274,  723,  274,  736,  839,  736,  274,
      929,  274,  550,  274,  274,  727,  734,  274,  274,  274,
      737,  735,  567,  738,  567,  928,  739,  274,  740,  274,
      274,  274,  274,  274,  274,  742,  741,  274,  274,  274,
      275,  745,  274,  276,  274,  744,  274,  274,  743,  205,
      274,  274,  274, 1182,  927, 1182,  574,  593,  736,  593,
      343,  205,  343,  345,  925,  345,  321,  321,  348,  321,
      348,  752,  936,  766,  567,  749,  574,  337,  321,  350,
      840,  350,  355,  357,  355,  357,  337,  604,  593,  604,

      593,  321,  337,  923,  321,  747,  918,  321,  359,  767,
      359,  337,  321,  748,  751, 1182,  339,  917,  339,  593,
      750,  754,  343,  321,  205,  345,  321,  321,  321,  900,
      348,  321,  756,  505,  755,  343,  345,  343,  345,  321,
      321,  350,  321,  922,  355,  357,  842,  337,  337,  604,
      593,  901,  763,  348,  763,  348,  350,  355,  350,  355,
      359,  903,  321,  357,  337,  357,  337,  337,  339,  604,
      761,  604,  916,  762,  359,  618,  359,  618,  205,  505,
      337,  764,  205,  915,  765,  337,  843,  343,  345,  337,
      337,  337,  505,  337,  337,  337,  337,  618,  772,  618,

      337,  941,  337,  920,  763,  348,  768,  205,  350,  355,
      769,  337,  505,  845,  781,  357,  781,  437,  321,  437,
      798,  604,  798,  205,  205,  505,  359,  618,  806,  205,
      806,  661,  679,  661,  679, 1042,  912,  205,  439,  337,
      337,  205,  437,  663,  437,  663,  205,  438,  438,  618,
      825,  952,  439,  437,  437,  437,  437,  437,  661,  437,
      661,  831,  205,  439,  439,  830,  781,  815,  663,  437,
      663,  679,  798,  679,  439,  439,  205,  940,  439,  439,
      806, 1028,  818,  661,  679,  820,  822,  829,  822,  439,
      832,  827,  832, 1097,  437,  663,  819,  205, 1126,  821,

      679,  683,  679,  683,  833,  437,  437,  337,  505,  437,
      661,  684,  505,  684,  823,  812,  855,  438,  438,  834,
      663,  848, 1132,  679,  836,  505,  834,  834,  834,  834,
      834,  834,  841,  685,  841,  685,  811,  205,  822,  837,
      810,  205,  832,  835,  505,  472,  837,  837,  837,  837,
      837,  837,  679,  683,  809,  844,  205,  505,  835,  505,
      717,  808,  717,  684, 1036,  835,  835,  835,  835,  835,
      835,  838,  505,  852,  721,  505,  721,  480,  723,  942,
      723,  727,  205,  727,  841,  685,  838,  505,  505,  505,
      846,  505,  847,  838,  838,  838,  838,  838,  838,  797,

      505,  505,  505,  794,  505,  505,  849,  505,  505,  505,
      850,  866,  717, 1137,  505,  505,  851,  736,  505,  736,
      505,  505,  505,  853,  505,  505,  721,  505,  505,  505,
      723,  793,  854,  727,  505,  858,  274,  505,  505,  505,
      505,  505,  505,  856,  505,  857, 1149,  505,  859,  872,
      860,  505,  505,  505,  505,  321,  862,  505,  861,  505,
      505,  863,  864,  505,  505,  274,  505,  274,  867,  736,
      865,  873,  505,  505,  274,  717,  505,  717,  875,  868,
      274,  868,  869,  870,  869,  870,  721,  274,  721,  871,
      723,  871,  723,  275,  321,  321,  276,  902,  792,  274,

      874,  274,  791,  727,  275,  727,  274,  276,  275,  274,
      274,  276,  274,  879,  876,  879,  274,  274,  877,  274,
      790,  275,  274,  274,  276,  337,  337,  717,  911,  274,
      274,  868,  274,  878,  869,  870,  274,  880,  721,  880,
      274,  871,  723,  274,  881,  274,  883,  274,  736,  882,
      736,  884,  205,  274,  274,  727,  274,  885,  274,  885,
      274,  274,  886,  274,  274,  879,  275,  274,  205,  276,
      887,  888,  274,  890,  274, 1038,  274,  274,  889,  891,
      889,  891,  789,  788,  274,  274,  343, 1039,  343,  880,
      345,  763,  345,  763,  348,  896,  348,  274,  337,  321,

      736,  350, 1013,  350,  321,  274,  274,  337,  321,  885,
      355,  897,  355,  321,  357,  359,  357,  359,  274,  274,
      321,  892,  894,  505,  321,  321,  786,  893,  321,  895,
      889,  891,  343,  784,  343,  321,  968,  345,  343,  345,
      205,  505,  345,  763,  321,  763,  348,  763,  321,  321,
      348,  899,  348,  350,  971,  778,  904,  898,  359, 1047,
      359,  337,  355,  337,  337,  777,  357,  359,  337,  337,
      337,  357,  350,  357,  350,  908,  781,  905,  781,  909,
      205,  337,  337,  337,  343,  914,  337,  914,  505,  345,
      906,  919,  337,  919,  781,  337,  781,  763,  776,  337,

      205,  972,  348,  337,  337,  910,  907, 1037,  337,  913,
      359,  959,  337,  337,  438,  438,  337,  337,  798,  806,
      798,  806,  775,  357,  350,  798,  774,  798,  781,  938,
      806,  938,  806,  679,  822,  679,  822,  914,  205,  950,
      951,  950,  951,  919,  746,  437,  781,  437,  205,  205,
      672,  437,  822,  437,  822,  439,  505,  437,  960,  437,
      960,  205,  953,  438,  438,  962,  439,  962,  945,  976,
      798,  806,  439,  439,  205,  337,  957,  798,  439,  955,
     1086,  938,  806,  954,  337,  679,  822,  205,  956,  438,
      438,  950,  951,  438,  438,  505,  958,  437,  841,  832,

      841,  832,  980,  437,  822,  833,  505,  967,  505,  437,
      960,  833,  321,  321, 1099, 1006,  671,  962, 1007,  505,
      834,  321,  321,  841,  670,  841,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  675,
      965,  969,  965,  505,  505,  836,  505,  970,  669,  205,
      841,  832,  648,  645,  676,  644,  981,  505,  836,  505,
      837,  676,  676,  676,  676,  676,  676,  837,  837,  837,
      837,  837,  837,  837,  677,  841,  868,  966,  868,  966,
      837,  837,  837,  837,  837,  837,  205,  630,  629,  678,
      628,  869,  965,  869,  627,  626,  678,  678,  678,  678,

      678,  678,  205,  505,  205,  870,  871,  870,  871,  505,
      973,  505,  974,  879,  978,  879,  505,  505,  505, 1168,
      625,  880,  505,  880,  505,  505,  975, 1105,  868,  966,
      505,  505,  505,  505,  274,  977,  505,  885,  505,  885,
      505,  505,  979,  869,  205,  505,  505,  274,  505,  505,
      505,  982,  988,  505,  505,  623,  274,  870,  871,  990,
      889,  505,  889,  505,  505,  879,  891, 1155,  891,  274,
      983,  621,  274,  880,  868,  274,  868,  505,  869,  614,
      869, 1060,  321,  870,  871,  870,  871,  505,  274,  885,
      985,  321,  275,  505,  505,  276,  275,  274,  274,  276,

      505,  275,  275,  987,  276,  276,  505,  986,  984,  986,
      274,  274,  889,  989,  505,  989,  274,  991,  891,  991,
      879,  880,  879,  880,  274,  992,  868,  505, 1055,  274,
      869,  994,  613,  274,  274,  870,  871,  274,  275,  275,
      274,  276,  276,  885,  274,  885,  274,  274,  993,  995,
      996,  995,  996,  274,  997,  205,  997,  274,  998,  986,
      998,  275,  274,  610,  276,  989,  889, 1008,  889,  991,
      321,  321,  879,  880, 1104, 1065,  274,  274,  891,  609,
      891,  274,  481,  321,  275,  274,  345,  276,  345,  274,
      274,  343,  321,  343,  274,  885,  275, 1003,  274,  276,

     1004,  995,  996,  505,  321,  348,  997,  348, 1058,  345,
      998,  345,  350,  321,  350,  999,  505,  357,  889,  357,
      321,  359,  914,  359,  914,  321, 1000,  343, 1052,  343,
      891,  438,  438,  438,  438,  348,  480,  348,  345,  321,
      337,  337, 1107,  343,  321, 1001, 1002,  914, 1077,  914,
     1010, 1005,  350,  321,  350,  321,  321,  348,  337,  337,
      473,  345,  337, 1009,  350,  472,  337,  337, 1014,  357,
     1011,  337,  505,  359,  914,  357,  205,  357, 1016,  343,
     1016,  467,  466,  337,  337,  505, 1017,  348, 1017,  919,
     1059,  919, 1018, 1012, 1018,  919, 1024,  919, 1024,  914,

     1026,  465, 1026,  337,  350,  205,  337,  464,  938,  205,
      938,  938,  337,  938,  337,  337, 1040, 1015, 1040, 1041,
      337, 1041,  950,  337,  950,  205,  505,  357,  205,  337,
     1016,  951,  950,  951,  950,  951,  205,  951, 1017, 1109,
      960,  919,  960,  437, 1018,  437,  205,  919, 1024,  437,
      205,  437, 1026,  962,  437,  962,  437, 1053, 1182, 1053,
      938,  439, 1182,  938,  439, 1054, 1182, 1054, 1040, 1156,
      439, 1041,  274, 1182,  950,  439, 1182, 1050,  960,  962,
      960,  962, 1051,  951,  950,  274, 1064,  951,  438,  438,
     1182,  205,  960, 1049, 1182,  437,  438,  438,  965,  439,

      965,  437,  966,  505,  966,  962,  437,  505,  965, 1053,
      965,  966, 1182,  966, 1056, 1182,  505, 1054, 1167,  986,
      505,  986, 1057,  505,  989,  991,  989,  991,  505, 1182,
      960,  962, 1061, 1182, 1182,  505,  505, 1182, 1182, 1182,
     1182,  505, 1063, 1062,  274,  995,  505,  995,  505, 1068,
      965,  505,  505,  996,  966,  996,  997,  274,  997,  505,
      965,  274, 1066,  966,  505,  505,  986,  998,  986,  998,
     1182,  986,  505,  274,  274, 1182,  989,  991, 1067,  274,
      505, 1111,  505,  505,  275,  505,  274,  276,  989, 1069,
      989, 1182,  274,  505,  505,  505,  505,  995, 1070,  991,

     1070,  991, 1071,  274, 1071,  996,  275,  505,  997,  276,
     1182, 1182, 1072,  995, 1072,  995, 1119,  275,  986,  998,
      276,  343, 1182,  343,  321,  274,  996, 1182,  996,  274,
     1078,  275,  505,  321,  276,  997, 1182,  997,  274,  274,
      989,  998,  274,  998,  275, 1143,  348,  276,  348, 1182,
     1070,  991,  274,  275, 1071,  321,  276, 1073,  345,  275,
      345,  350,  276,  350, 1072,  995,  357, 1016,  357, 1016,
     1017, 1182, 1017,  343, 1182, 1018, 1182, 1018,  996, 1182,
      321, 1075, 1182, 1016,  343, 1016,  343,  997,  345,  348,
      345,  348,  321,  998, 1017,  321, 1017, 1182,  348, 1074,

      321,  321, 1076, 1182,  321,  350, 1182,  350, 1079,  321,
      345, 1080,  337,  350,  337,  505,  337, 1081,  357, 1016,
     1112,  337, 1017,  337, 1182,  337,  337, 1018,  505, 1018,
     1082, 1018,  357,  337,  357, 1016,  343, 1024, 1182, 1024,
      345,  348,  337, 1087, 1182, 1087, 1017, 1024, 1026, 1024,
     1026, 1026,  205, 1026, 1089, 1182, 1089,  350, 1182, 1040,
      337, 1040, 1041,  205, 1041, 1096, 1098, 1096, 1098,  337,
     1040, 1182, 1040, 1083,  205,  205, 1041, 1103, 1041, 1103,
      437, 1018,  437, 1053,  357, 1053,  205, 1182, 1054, 1024,
     1054, 1053, 1054, 1053, 1054, 1087, 1182,  505, 1110, 1024,

     1026,  439,  505, 1026,  439, 1182, 1089,  505, 1106,  439,
      505, 1040,  439,  439, 1041,  505, 1108, 1096, 1098, 1070,
      505, 1070, 1040, 1113, 1071, 1072, 1071, 1072, 1041, 1103,
     1182, 1087,  437, 1087, 1114, 1053, 1114,  274, 1115, 1116,
     1054, 1116,  274, 1053, 1054, 1117,  505, 1117, 1182, 1182,
      274,  505,  505, 1182, 1182,  274, 1118, 1182, 1182,  505,
     1070,  274, 1070, 1182,  505,  505,  274, 1087,  343, 1087,
      343, 1070,  274,  345,  274,  345, 1071, 1072,  275,  274,
     1071,  276, 1071, 1087,  321,  274, 1114, 1072,  348, 1072,
      348, 1116,  350,  321,  350, 1120, 1182, 1117,  275, 1182,

     1122,  276,  321, 1182,  357,  275,  357,  321,  276,  343,
     1182,  343, 1070, 1182, 1182,  348, 1121,  348, 1182, 1087,
      343,  357,  321,  357, 1182,  345,  321, 1128, 1089, 1128,
     1089, 1089, 1071, 1089,  505, 1141,  205,  337,  321, 1072,
      348, 1182, 1125,  337,  350, 1123,  337,  505, 1182,  337,
     1124, 1096,  337, 1096, 1182, 1098,  357, 1098,  337, 1182,
     1096,  343, 1096, 1133, 1098, 1133, 1098,  348, 1134, 1103,
     1134, 1103,  205,  357, 1103, 1182, 1103,  205,  274, 1128,
     1089,  274, 1145, 1089,  437, 1182,  437, 1140,  505, 1140,
     1114,  274, 1114, 1144,  274, 1116, 1182, 1116, 1117, 1182,

     1117,  505, 1142, 1096, 1182,  439, 1182, 1098, 1182, 1182,
     1182, 1114, 1096, 1114, 1182, 1133, 1098,  505,  438,  438,
     1134, 1103,  505, 1182, 1139,  505, 1103,  274, 1146,  275,
      505, 1116,  276, 1116, 1182,  505,  437, 1182,  505, 1140,
      274, 1117, 1114, 1117,  343, 1182,  343, 1116, 1182,  275,
     1117, 1182,  276,  348,  357,  348,  357, 1182,  343,  275,
      343, 1182,  276, 1114, 1182, 1128,  348, 1128,  348, 1128,
     1133, 1128, 1133, 1134, 1133, 1134, 1133, 1134,  321, 1134,
     1148, 1182, 1152, 1116, 1152, 1147,  337,  321,  321,  505,
     1140,  205, 1140, 1117, 1182,  337,  343,  337, 1150, 1140,

     1182, 1140,  505, 1182, 1157,  348,  357,  343, 1182,  343,
      343,  439, 1182, 1182,  505, 1158, 1182, 1128,  348, 1182,
      439, 1128, 1133,  505, 1159, 1134, 1133,  505, 1160, 1134,
     1160, 1161, 1182, 1161, 1152, 1162,  505, 1162,  348, 1182,
      348,  321, 1140, 1182, 1152,  348, 1152,  348, 1152, 1182,
     1152, 1140, 1160, 1182, 1160,  274, 1182, 1182,  274,  343,
     1182, 1161,  274, 1161, 1182, 1182, 1182, 1182,  274, 1164,
     1163,  274,  321,  337, 1182,  274, 1162, 1182, 1162,  505,
     1160, 1182,  337, 1161, 1160, 1182, 1160, 1162,  505, 1161,
      348, 1161,  505, 1162, 1182, 1162, 1152,  348, 1182, 1182,

     1152,  505,  275,  505, 1160,  276,  348,  275,  348, 1182,
      276,  275, 1182, 1161,  276,  348,  505,  348, 1174,  348,
     1174,  348,  348, 1174,  348, 1174, 1182,  205, 1162, 1178,
     1169, 1178, 1174, 1182, 1174,  348, 1160,  348,  205, 1182,
      321, 1161, 1178,  337, 1178, 1162, 1178, 1182, 1178,  348,
     1176,  348,  337,  321,  348, 1182,  348, 1170,  348,  337,
     1182, 1175,  348, 1179,  348, 1182, 1182,  348, 1182,  321,
     1174,  348, 1182, 1182,  348, 1174,  348,  337,  348, 1182,
     1182, 1178, 1182, 1182, 1174, 1182,  337,  348,  321, 1182,
     1180, 1182, 1182, 1182, 1178, 1181,  321, 1182, 1178, 1182,

     1182,  348, 1182, 1182,  337, 1182,  348, 1182, 1182, 1182,
     1182, 1182, 1182,  337,  348, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,  348,  204,
      204,  204,  206,  206,  206,  206,  206,  206,  206,  214,
      214,  214,  214,  214,  214,  214,  226,  226,  226,  226,
      274,  274,  274,  274,  274,  274,  278,  278,  278,  278,
      278,  337,  337,  337,  337,  438,  438,  438,  438, 1182,
      438,  505,  505,  505, 1182,  505,  505,  254,  254,  254,
     1182,  254,  321,  321,  654,  654,  654, 1182, 1182,  654,
      674,  674, 1182, 1182,  674,  674,  674,   31, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182
    } ;

static const short int yy_chk[4653] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,

        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    9,   54,    9,  143,
       11,   12,   11,   12,   57,   10,   13,   10,   13,   25,
       14,   25,   14,  149,   26,   27,   26,   27,  146,   55,
      472,   34,   56,   34,   28,  472,   28,    9,   11,   12,
      143,   57,    9,    9,   13,   54,   10,    9,   14,  375,
        9,   10,   10,   21,  149,   21,   10,   55,    9,   10,
       56,   25,   11,   12,   84,  146,   26,   10,   13,   27,
       85,   25,   14,   15,  375,   15,   26,   27,   28,  419,
       21,   21,   21,   34,   86,  419,   28,   29,   29,   29,

       37,   22,   37,   22,   21,   98,   87,   15,   85,   58,
      100,   15,   84,  137,   88,   21,   29,   15,   98,   15,
      100,   15,   86,  100,   15,   98,   15,   15,   22,   22,
       22,   58,   58,   87,  102,   15,   88,   88,  258,   29,
     1171,  137,   22,  371,  102,  199,  199,  102,  258,   29,
      371,  258,   37,   22,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   30,   30,
       30,  150,   38,   40,   38,   40,  136,  113,   42,   38,
       42,  113,  113,  643,  151,  155,   43,   30,   43,   42,
      113,  136,   44,   45,   44,   45,   46,   47,   46,   47,
       48,   50,   48,   50,   61,   46,   61,  151,  150,   48,
       30,  140,  155,   47,  155,  643,   62,   48,   62,  139,
       30,   33,   33,   33,   38,   40,  140,   33,   33, 1166,
       42,   33,   33,   33,   33,   33,   33,   33,   43, 1165,
       33,   33,   33,   33,   44,   45,   33,  403,   46,   47,
       33,  403,   48,   50,  217,   61,   61,  139,   51,   67,

       51,   67,  106,   33,   33,   52,   33,   52,   62,  154,
       33,   33,   33,   33,   36,  106,   36,  106,   36,   51,
       51,   70,   68,   70,   68,   52,   52,   52,   53,   68,
       53,   36,  217,   59,   72,   59,   72,  154,   36,   36,
       36,   36,   36,   36, 1154,   72,  337,  337,   53,   53,
       51,   67,  377,   59,   59,   59,   60,   52,   60,   73,
       74,   73,   74,   75,  152,   75,   36,   39, 1153,   39,
      104,  104,  377,   70,   68,   39,   60,   60,   60,   76,
       53,   76, 1136,  104,   39,   59,   72,   77,   76,   77,
      159,   39,   39,   39,   39,   39,   39,  376,  152,   80,

       78,   80,   78,   77,   81,  108,   81,   99,   60,   78,
       99,   73,   74,  159,   82,   75,   82,   78,  108,   39,
       66,  108,   66,   99,   66,   81,   81,  160,   92,  354,
       92,   76,  376,  162,   82,   82,   82,   66,  354,   77,
       83,  354,   83,  379,   66,   66,   66,   66,   66,   66,
      162,   80,   78,   91,  160,   91,   81,   89,  105,   89,
       83,   83,   90,  114,   90,  114,   82,   94,  105,   94,
      379,  105,   66,   69,  105,   69,   94,   89,   89,   89,
       92,   69,   90,   90,   90,   94,  407,  153,   94,  402,
       69,  402,   83,  109,  109,  241,  161,   69,   69,   69,

       69,   69,   69,  101,   91,   91,  109,  111,  616,   89,
      101,  111,  101,  407,   90,  114,  101,  111,  241,   94,
      111,  153,  101,  616,  161,   69,   93,   93,   93,   93,
      161,   93,   93,   93,  364,  364,   93,   93,   93,   93,
       93,   93,   93,   93,  209,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   95,
     1135,   95,   96,   97,   96,   97,  209, 1129,   95,  238,
     1102,   96,   97,  103,  112,  103,  173,   95,  410,   96,

       96,   97,  103,  112,   97,  112,  103,  112,  103,  107,
       97,  110,  107,  138,  110,  110,  262,  262,  173,  110,
      238,  240,  386,   97,  173,  107,  156,  110,  107,  262,
     1101,   95,  410,  138,   96,   97,  115,  115,  115,  115,
      138,  156,  115,  115, 1094,  156,  115,  115,  115,  115,
      115,  115,  115,  386,  240,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  116,
      803,  116,  116, 1092,  116,  242,  256,  118,  116,  118,

      118,  347,  347,  134,  116,  134,  116,  803,  266,  256,
      347,  119,  116,  119,  119,  120,  256,  120,  120,  257,
      118,  266,  257,  121,  266,  121,  121,  353,  242,  353,
      122,  118,  122,  122,  119,  257,  353,  123,  120,  123,
      123,  116,  117,  380,  117,  117,  121,  117,  274,  118,
     1090,  117,  120,  122,  141,  134,  141,  117,  119,  117,
      123,  274,  392,  119,  157,  117,  157,  120,  380,  124,
      122,  124,  124,  281,  123,  121,  125,  405,  125,  125,
      260,  126,  122,  126,  126,  127,  281,  127,  127,  123,
      260,  392,  124,  260,  117,  128,  449,  128,  405,  125,

      125,  129,  449,  129,  126,  124,  141,  282,  127,  126,
      282,  130,  284,  130,  127,  131,  157,  131,  126,  284,
      282,  124,  132,  128,  132,  284,  426,  129,  125,  129,
      425,  269,  128,  126,  133,  269,  133,  127,  129,  130,
      142,  269,  142,  131,  269,  264,  132,  128,  130,  426,
      132,  131,  131,  129,  135,  144,  135,  144,  264,  132,
      264,  265,  133,  130,  265,  133,  133,  131,  142,  425,
      163,  133,  163,  145,  132,  145,  147,  265,  147, 1084,
      265,  288,  158,  144,  158,  135,  133,  165,  406,  165,
      135,  135,  142,  409,  288,  135,  165,  495,  135,  413,

      171,  145,  171,  166,  147,  166,  135,  144,  165,  158,
      158,  158,  166,  424,  175,  408,  175,  167,  409,  167,
      495,  406,  163,  158,  166,  145,  167,  263,  147,  148,
      413,  148,  290,  261,  158,  261, 1045,  263,  167,  165,
      263,  408,  261,  263,  424,  290,  261,  170,  261,  170,
      166,  296,  171,  148,  167,  166,  170,  148,  175,  296,
     1105,  267,  267,  148,  296,  148,  175,  148,  170,  167,
      148,  411,  148,  148,  267,  362,  362,  287,  170,  170,
     1105,  148,  164,  164,  164,  164,  362,  164,  164,  164,
      287,  287,  164,  164,  164,  164,  164,  164,  164,  170,

      411,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  168,  286,  168,  169,  172,
      169,  172, 1044,  174,  168,  174,  286,  169,  176,  286,
      176,  177,  177,  177,  496,  178,  168,  178,  179,  169,
      179,  180,  182,  180,  182,  183,  184,  183,  184,  186,
      177,  186,  168,  184,  169,  187,  188,  187,  188,  496,
      186,  172,  189,  497,  189,  174,  190,  168,  190, 1043,
      169,  172,  176,  177, 1035,  174,  191, 1032,  191,  194,

      176,  194,  192,  177,  192,  497,  203,  178,  203,  193,
      179,  193,  191,  180,  182,  365,  365,  183,  184,  194,
      194,  186,  422,  192,  192,  620,  365,  187,  188,  193,
      193,  193, 1031,  294,  189,  200,  294,  200,  190,  201,
      205,  201,  205,  422,  211,  212,  211,  212,  191,  294,
      292,  194,  212,  295,  192,  200,  200,  200,  203,  620,
      213,  193,  213,  292,  295,  292,  295,  423,  363,  363,
      219,  363,  219,  298,  220,  221,  220,  221,  222,  223,
      222,  223,  224,  632,  224,  220,  298,  200,  423,  632,
      201,  201,  205,  208,  641,  208,  211,  212, 1030,  225,

      226,  225,  226,  615,  228,  231,  228,  231,  208,  226,
     1029,  230,  213,  230, 1027,  208,  208,  208,  208,  208,
      208,  210,  219,  210, 1020,  210,  220,  221,  641,  412,
      222,  223,  230,  230,  224,  232,  615,  232,  210,  227,
      234,  227,  234,  438,  438,  210,  210,  210,  210,  210,
      210,  225,  226,  289,  412,  227,  228,  231,  289,  229,
      412,  229,  233,  230,  233,  235,  289,  235,  229,  237,
      239,  237,  239,  210,  216,  451,  229,  297,  237,  239,
      216,  297,  233,  233,  233, 1019,  236,  232,  236,  216,
      297,  227,  234,  247,  451,  247,  216,  216,  216,  216,

      216,  216,  218,  243,  218,  243,  236,  236,  444,  444,
      218,  229,  639,  244,  233,  244,  248,  235,  248,  218,
      947,  237,  239,  243,  243,  243,  218,  218,  218,  218,
      218,  218, 1014,  250,  244,  250,  303,  245,  236,  245,
      246, 1014,  246,  639,  247,  247,  252,  619,  252,  303,
      275,  253,  275,  253,  218,  243,  303,  245,  245,  245,
      254,  246,  254,  505,  252,  244,  270,  252,  248,  253,
      255,  276,  255,  276,  259,  270,  505,  270,  254,  270,
      619,  259,  944,  259,  314,  250,  314,  259,  255,  245,
      943,  255,  246,  259,  934,  271,  635,  255,  252,  271,

      271,  268,  275,  253,  268,  268,  787,  304,  271,  268,
      255,  273,  254,  273,  304,  635,  277,  268,  277,  278,
      304,  278,  255,  276,  279,  283,  279,  283,  278,  273,
      933,  280,  273,  280,  277,  668,  314,  278,  787,  285,
      280,  285,  279,  293,  293,  291,  300,  291,  280,  280,
      932,  299,  283,  300,  301,  301,  293,  306,  306,  300,
      300,  299,  668,  273,  299,  283,  285,  301,  277,  302,
      306,  278,  291,  480,  480,  305,  279,  283,  305,  285,
      931,  309,  302,  280,  302,  291,  929,  307,  305,  307,
      308,  285,  310,  308,  309,  312,  309,  291,  506,  311,

      311,  590,  590,  310,  311,  310,  308,  319,  312,  319,
      312,  506,  311,  316,  307,  316,  316,  317,  509,  317,
      317,  318,  928,  318,  318,  509,  320,  307,  320,  927,
      321,  509,  321,  323,  636,  323,  316,  473,  513,  307,
      317,  319,  473,  322,  318,  322,  327,  325,  327,  325,
      324,  513,  324,  636,  319,  318,  605,  605,  925,  319,
      320,  608,  608,  320,  321,  316,  326,  323,  326,  317,
      323,  325,  330,  318,  330,  327,  923,  322,  320,  473,
      327,  325,  321,  322,  324,  323,  324,  328,  329,  328,
      329,  331,  583,  331,  326,  322,  920,  637,  327,  325,

      326,  583,  324,  326,  583,  335,  330,  335,  332,  330,
      332,  336,  918,  336,  329,  328,  637,  333,  326,  333,
     1167,  328,  329,  652,  330,  331,  338,  331,  338,  339,
      920,  339,  332,  340,  341,  340,  341,  515,  813,  328,
      329, 1167,  332,  331,  342,  343,  342,  343,  333,  333,
      515,  333,  344,  345,  344,  345,  348,  335,  348,  346,
      332,  346,  652,  336,  340,  340,  350,  340,  350,  333,
      349,  813,  349,  664,  664,  342,  342,  352,  338,  352,
      355,  339,  355,  344,  344,  340,  341,  344,  666,  666,
      346,  346,  351,  357,  351,  357,  342,  343,  356,  346,

      356,  349,  349,  921,  344,  345,  622,  359,  348,  359,
      782,  346,  349,  367,  358,  367,  358,  351,  350,  360,
      948,  360,  349,  351,  351,  782,  356,  356,  378,  352,
      378,  382,  355,  382,  622,  356,  361,  378,  361,  383,
      921,  383,  358,  360,  351,  357,  385,  360,  385,  917,
      356,  358,  948,  441,  441,  358,  360,  916,  387,  359,
      387,  388,  441,  388,  361,  367,  358,  383,  389,  638,
      389,  360,  624,  361,  385,  391,  393,  391,  393,  394,
      378,  394,  415,  382,  415,  428,  387,  428,  361,  388,
      430,  383,  430,  431,  638,  431,  389,  434,  385,  434,

      624,  443,  443,  391,  393,  445,  445,  394,  518,  518,
      387,  430,  443,  388,  431,  432,  445,  432,  434,  640,
      389,  518,  433,  435,  433,  435,  785,  391,  393,  830,
      437,  394,  437,  434,  415, 1036,  432,  428,  640,  440,
      431,  440,  430,  433,  435,  431,  442,  829,  442,  434,
     1036,  437,  432,  649,  435,  435,  447,  785,  447,  433,
      448,  450,  448,  450,  452,  827,  452,  432,  606,  606,
      440,  440,  481,  481,  433,  435,  649,  442,  442,  453,
      606,  453,  437,  454,  455,  454,  455,  459,  456,  459,
      456,  440,  461,  457,  461,  457,  653,  463,  442,  463,

      812,  507,  448,  450,  507,  464,  452,  464,  447,  466,
      481,  466,  448,  450,  507,  653,  452,  471,  474,  471,
      474,  453,  588,  588,  799,  514,  519,  454,  455,  519,
      514,  453,  456,  588,  523,  454,  455,  457,  514,  459,
      456,  479,  519,  479,  461,  457,  470,  523,  470,  463,
      477,  482,  486,  482,  486,  799,  484,  464,  487,  811,
      487,  466,  488,  809,  488,  477,  470,  470,  470,  471,
      474,  484,  477,  477,  477,  477,  477,  477,  484,  484,
      484,  484,  484,  484,  489,  490,  489,  490,  491,  492,
      491,  492,  493,  479,  493,  494,  533,  494,  470,  533,

      498,  493,  498,  482,  486,  499,  500,  499,  500,  501,
      487,  501,  533,  502,  488,  502,  504,  503,  504,  503,
      511,  498,  508,  510,  508,  510,  500,  500,  500,  512,
      511,  808,  516,  511,  516,  520,  489,  490,  503,  797,
      491,  492,  512,  512,  493,  795,  520,  494,  520,  508,
      510,  517,  498,  589,  589,  814,  589,  499,  500,  516,
      540,  501,  508,  510,  517,  502,  517,  522,  504,  503,
      521,  522,  516,  540,  508,  510,  524,  794,  521,  528,
      522,  525,  814,  521,  516,  527,  524,  801,  525,  524,
      526,  526,  528,  530,  525,  525,  530,  529,  527,  528,

      527,  531,  531,  526,  529,  532,  530,  532,  534,  535,
      529,  536,  536,  537,  531,  538,  536,  538,  801,  650,
      535,  534,  535,  534,  536,  539,  537,  539,  537,  541,
      543,  541,  532,  542,  544,  542,  544,  543,  591,  591,
      546,  546,  650,  543,  547,  532,  547,  545,  548,  591,
     1078,  542,  544,  546,  542,  544,  541,  532,  545, 1078,
      545,  548,  549,  548,  549,  551,  551,  538,  793,  541,
      550,  547,  550,  554,  552,  554,  952,  539,  551,  792,
      553,  541,  555,  555,  547,  542,  544,  552,  550,  549,
      557,  550,  680,  553,  559,  555,  547,  553,  556,  556,

      554,  559,  549,  557,  557,  558,  558,  559,  560,  952,
      561,  556,  560,  554,  549,  562,  563,  680,  563,  558,
      791,  560,  550,  561,  565,  554,  561,  566,  562,  564,
      564,  562,  567,  565,  567,  790,  566,  565,  568,  568,
      566,  569,  564,  563,  570,  570,  569,  573,  572,  571,
      567,  573,  568,  567,  569,  572,  563,  570,  571,  800,
      573,  572,  571,  574,  789,  574,  574,  576,  563,  576,
      577,  681,  577,  578,  786,  578,  579,  579,  580,  582,
      580,  582,  800,  599,  567,  579,  574,  599,  582,  581,
      681,  581,  584,  585,  584,  585,  599,  587,  593,  587,

      593,  576,  600,  784,  577,  577,  778,  578,  586,  600,
      586,  600,  580,  578,  581,  574,  592,  777,  592,  576,
      580,  584,  577,  581,  783,  578,  584,  585,  757,  757,
      580,  587,  586,  686,  585,  594,  595,  594,  595,  758,
      758,  581,  586,  783,  584,  585,  686,  592,  592,  587,
      593,  758,  596,  597,  596,  597,  598,  601,  598,  601,
      586,  760,  760,  602,  595,  602,  594,  594,  592,  604,
      594,  604,  775,  595,  603,  612,  603,  612,  780,  688,
      596,  597,  805,  774,  598,  601,  688,  594,  595,  596,
      597,  602,  688,  598,  601,  607,  607,  618,  607,  618,

      602,  805,  603,  780,  596,  597,  602,  942,  598,  601,
      603,  603,  690,  690,  617,  602,  617,  654,  746,  654,
      634,  604,  634,  617,  817,  690,  603,  612,  642,  634,
      642,  655,  651,  655,  651,  942,  771,  642,  654,  771,
      771,  651,  656,  657,  656,  657,  804,  665,  665,  618,
      665,  817,  655,  659,  658,  659,  658,  660,  661,  660,
      661,  672,  926,  656,  657,  671,  617,  651,  663,  654,
      663,  669,  634,  669,  659,  658, 1038,  804,  660,  661,
      642,  926,  656,  655,  651,  659,  662,  670,  662,  663,
      673,  667,  673, 1038,  656,  657,  658, 1095, 1082,  660,

      679,  683,  679,  683,  675,  659,  658, 1082,  695,  660,
      661,  684,  703,  684,  662,  648,  703,  662,  662,  675,
      663,  695, 1095,  669,  677,  703,  675,  675,  675,  675,
      675,  675,  682,  685,  682,  685,  647,  935,  662,  677,
      646,  682,  673,  676,  689,  676,  677,  677,  677,  677,
      677,  677,  679,  683,  645,  689,  807,  689,  676,  700,
      687,  644,  687,  684,  935,  676,  676,  676,  676,  676,
      676,  678,  700,  700,  691,  692,  691,  678,  693,  807,
      693,  697, 1104,  697,  682,  685,  678,  687,  692,  696,
      692,  694,  694,  678,  678,  678,  678,  678,  678,  633,

      687,  691,  696,  631,  694,  693,  696,  715,  697,  698,
      698,  715,  687, 1104,  691,  699,  699,  706,  693,  706,
      715,  697,  698,  701,  701,  702,  691,  704,  699,  705,
      693,  630,  702,  697,  707,  707,  724,  701,  702,  708,
      704,  709,  705,  704,  706,  705, 1122,  707,  708,  724,
      709,  711,  708,  713,  709, 1122,  711,  706,  710,  710,
      712,  712,  713,  714,  711,  728,  713,  716,  716,  706,
      714,  725,  710,  712,  725,  717,  714,  717,  728,  718,
      716,  718,  719,  720,  719,  720,  721,  725,  721,  722,
      723,  722,  723,  717,  759,  759,  717,  759,  629,  726,

      726,  729,  628,  727,  721,  727,  718,  721,  723,  719,
      720,  723,  726,  732,  729,  732,  722,  730,  730,  718,
      627,  727,  719,  720,  727,  770,  770,  717,  770,  722,
      730,  718,  731,  731,  719,  720,  735,  733,  721,  733,
      732,  722,  723,  734,  734,  731,  737,  737,  736,  735,
      736,  738,  937,  732,  738,  727,  734,  739,  742,  739,
      737,  740,  740,  741,  733,  732,  736,  738,  939,  736,
      741,  742,  744,  744,  740,  937,  741,  733,  743,  745,
      743,  745,  626,  625,  739,  744,  747,  939,  747,  733,
      748,  749,  748,  749,  750,  752,  750,  739,  908,  752,

      736,  751,  908,  751,  753,  743,  745,  908,  752,  739,
      754,  753,  754,  753,  755,  756,  755,  756,  743,  745,
      747,  747,  750,  847,  748,  749,  623,  748,  750,  751,
      743,  745,  761,  621,  761,  751,  847,  762,  747,  762,
      949,  850,  748,  749,  754,  763,  750,  763,  755,  756,
      764,  756,  764,  751,  850,  614,  761,  755,  769,  949,
      769,  766,  754,  761,  761,  613,  755,  756,  762,  762,
      766,  768,  765,  768,  765,  766,  776,  762,  776,  767,
      936,  764,  764,  767,  761,  773,  769,  773,  851,  762,
      764,  779,  767,  779,  781,  769,  781,  763,  611,  768,

      779,  851,  764,  765,  765,  768,  765,  936,  768,  772,
      769,  825,  772,  772,  825,  825,  773,  773,  788,  796,
      788,  796,  610,  768,  765,  798,  609,  798,  776,  802,
      806,  802,  806,  810,  818,  810,  818,  773,  802,  815,
      816,  815,  816,  779,  575,  820,  781,  820,  815,  816,
      469,  819,  822,  819,  822,  818,  857,  821,  826,  821,
      826, 1022,  818,  823,  823,  828,  820,  828,  810,  857,
      788,  796,  819,  822,  828, 1126,  823,  798,  821,  820,
     1022,  802,  806,  819, 1126,  810,  818, 1042,  821,  826,
      826,  815,  816,  824,  824,  862,  824,  820,  831,  832,

      831,  832,  862,  819,  822,  833,  842,  842,  862,  821,
      826,  834,  900,  900, 1042,  900,  468,  828,  901,  842,
      833,  901,  901,  841,  467,  841,  834,  833,  833,  833,
      833,  833,  833,  834,  834,  834,  834,  834,  834,  835,
      839,  848,  839,  863,  848,  836,  849,  849,  465,  839,
      831,  832,  420,  418,  835,  417,  863,  848,  837,  849,
      836,  835,  835,  835,  835,  835,  835,  836,  836,  836,
      836,  836,  836,  837,  838,  841,  843,  840,  843,  840,
      837,  837,  837,  837,  837,  837,  840,  401,  400,  838,
      399,  844,  839,  844,  398,  397,  838,  838,  838,  838,

      838,  838, 1156,  843, 1048,  845,  846,  845,  846,  852,
      852,  853,  853,  854,  859,  854,  843,  859,  844, 1156,
      396,  855,  852,  855,  853,  856,  856, 1048,  843,  840,
      859,  844,  845,  846,  876,  858,  858,  860,  856,  860,
      854,  861,  861,  844, 1137,  845,  846,  876,  855,  858,
      865,  865,  876,  854,  861,  390,  867,  845,  846,  878,
      864,  855,  864,  865,  860,  854,  866, 1137,  866,  867,
      867,  384,  878,  855,  868,  873,  868,  860,  869,  373,
      869,  974, 1149,  870,  871,  870,  871,  864,  873,  860,
      873, 1149,  868,  866,  974,  868,  869,  872,  875,  869,

      864,  870,  871,  875,  870,  871,  866,  874,  872,  874,
      872,  875,  864,  877,  967,  877,  882,  881,  866,  881,
      879,  880,  879,  880,  884,  882,  868,  967,  967,  882,
      869,  884,  372,  883,  874,  870,  871,  884,  879,  880,
      877,  879,  880,  885,  881,  885,  883,  874,  883,  886,
      887,  886,  887,  877,  888, 1047,  888,  881,  890,  874,
      890,  885,  984,  370,  885,  877,  889,  902,  889,  881,
      902,  902,  879,  880, 1047,  984,  886,  887,  891,  369,
      891,  888,  215,  896,  889,  890,  893,  889,  893,  886,
      887,  892,  896,  892,  888,  885,  891,  896,  890,  891,

      897,  886,  887,  971,  897,  894,  888,  894,  971,  905,
      890,  905,  895,  897,  895,  892,  971,  898,  889,  898,
      893,  899,  903,  899,  903,  892,  893,  904,  957,  904,
      891,  957,  957, 1052, 1052,  906,  214,  906,  893,  894,
      905,  905, 1052,  892, 1003,  894,  895,  914, 1003,  914,
      905,  898,  907, 1003,  907,  899,  903,  894,  904,  904,
      207,  905,  909,  904,  895,  206,  906,  906,  909,  898,
      906,  909,  972,  899,  903,  910,  204,  910,  911,  904,
      911,  198,  197,  907,  907,  972,  912,  906,  912,  915,
      972,  915,  913,  907,  913,  919,  922,  919,  922,  914,

      924,  196,  924,  910,  907,  922,  911,  195,  930,  924,
      930,  938,  910,  938,  912,  911,  940,  910,  940,  941,
      913,  941,  945,  912,  945,  940, 1056,  910,  941,  913,
      911,  946,  950,  946,  950,  951,   65,  951,  912, 1056,
      956,  915,  956,  954,  913,  954, 1138,  919,  922,  953,
       35,  953,  924,  961,  955,  961,  955,  958,   31,  958,
      930,  956,    0,  938,  954,  959,    0,  959,  940, 1138,
      953,  941,  983,    0,  945,  955,    0,  954,  960,  962,
      960,  962,  955,  946,  950,  983,  983,  951,  958,  958,
        0, 1155,  956,  953,    0,  954,  959,  959,  963,  960,

      963,  953,  964,  968,  964,  961,  955,  969,  965,  958,
      965,  966,    0,  966,  968,    0,  968,  959, 1155,  970,
      969,  970,  969,  976,  973,  975,  973,  975,  977,    0,
      960,  962,  976,    0,    0,  978,  976,    0,    0,    0,
        0,  977,  978,  977,  988,  979,  970,  979,  978,  988,
      963,  973,  975,  980,  964,  980,  981,  988,  981,  970,
      965,  985,  985,  966,  973,  975,  986,  982,  986,  982,
        0,  970,  979,  990,  985,    0,  973,  975,  987,  987,
      980, 1058, 1058,  981,  986,  979,  990,  986,  989,  990,
      989,    0,  987,  980,  982, 1058,  981,  979,  992,  991,

      992,  991,  993, 1069,  993,  980,  989,  982,  981,  989,
        0,    0,  994,  995,  994,  995, 1069,  991,  986,  982,
      991,  999,    0,  999, 1004,  992,  996,    0,  996,  993,
     1004,  995, 1113, 1004,  995,  997,    0,  997,  992,  994,
      989,  998,  993,  998,  996, 1113, 1001,  996, 1001,    0,
      992,  991,  994,  997,  993,  999,  997,  999, 1000,  998,
     1000, 1002,  998, 1002,  994,  995, 1005, 1006, 1005, 1006,
     1007,    0, 1007,  999,    0, 1008,    0, 1008,  996,    0,
     1001, 1001,    0, 1016, 1009, 1016, 1009,  997, 1010, 1011,
     1010, 1011, 1000,  998, 1017, 1002, 1017,    0, 1001, 1000,

     1005, 1006, 1002,    0, 1007, 1012,    0, 1012, 1005, 1008,
     1000, 1009, 1009, 1002, 1013, 1059, 1010, 1011, 1005, 1006,
     1059, 1009, 1007, 1013,    0, 1010, 1011, 1008, 1059, 1018,
     1013, 1018, 1015, 1012, 1015, 1016, 1009, 1021,    0, 1021,
     1010, 1011, 1012, 1023,    0, 1023, 1017, 1024, 1025, 1024,
     1025, 1026, 1023, 1026, 1028,    0, 1028, 1012,    0, 1033,
     1015, 1033, 1034, 1028, 1034, 1037, 1039, 1037, 1039, 1015,
     1040,    0, 1040, 1015, 1037, 1039, 1041, 1046, 1041, 1046,
     1049, 1018, 1049, 1050, 1015, 1050, 1046,    0, 1051, 1021,
     1051, 1053, 1054, 1053, 1054, 1023,    0, 1057, 1057, 1024,

     1025, 1049, 1055, 1026, 1050,    0, 1028, 1060, 1049, 1051,
     1057, 1033, 1053, 1054, 1034, 1055, 1055, 1037, 1039, 1061,
     1060, 1061, 1040, 1060, 1062, 1063, 1062, 1063, 1041, 1046,
        0, 1085, 1049, 1085, 1064, 1050, 1064, 1065, 1065, 1066,
     1051, 1066, 1068, 1053, 1054, 1067, 1061, 1067,    0,    0,
     1065, 1062, 1063,    0,    0, 1068, 1068,    0,    0, 1061,
     1070, 1064, 1070,    0, 1062, 1063, 1066, 1087, 1073, 1087,
     1073, 1061, 1067, 1074, 1064, 1074, 1062, 1063, 1070, 1066,
     1071, 1070, 1071, 1085, 1077, 1067, 1064, 1072, 1075, 1072,
     1075, 1066, 1076, 1077, 1076, 1073,    0, 1067, 1071,    0,

     1077, 1071, 1073,    0, 1079, 1072, 1079, 1074, 1072, 1080,
        0, 1080, 1070,    0,    0, 1081, 1075, 1081,    0, 1087,
     1073, 1083, 1075, 1083,    0, 1074, 1076, 1086, 1088, 1086,
     1088, 1089, 1071, 1089, 1109, 1109, 1086, 1080, 1079, 1072,
     1075,    0, 1081, 1081, 1076, 1079, 1080, 1109,    0, 1083,
     1080, 1091, 1081, 1091,    0, 1093, 1079, 1093, 1083,    0,
     1096, 1080, 1096, 1097, 1098, 1097, 1098, 1081, 1099, 1100,
     1099, 1100, 1097, 1083, 1103,    0, 1103, 1099, 1115, 1086,
     1088, 1118, 1118, 1089, 1106,    0, 1106, 1107, 1112, 1107,
     1108, 1115, 1108, 1115, 1118, 1110,    0, 1110, 1111,    0,

     1111, 1112, 1112, 1091,    0, 1106,    0, 1093,    0,    0,
        0, 1114, 1096, 1114,    0, 1097, 1098, 1108, 1107, 1107,
     1099, 1100, 1110,    0, 1106, 1111, 1103, 1119, 1119, 1114,
     1108, 1116, 1114, 1116,    0, 1110, 1106,    0, 1111, 1107,
     1119, 1117, 1108, 1117, 1120,    0, 1120, 1110,    0, 1116,
     1111,    0, 1116, 1121, 1123, 1121, 1123,    0, 1124, 1117,
     1124,    0, 1117, 1114,    0, 1127, 1125, 1127, 1125, 1128,
     1130, 1128, 1130, 1131, 1133, 1131, 1133, 1134, 1120, 1134,
     1121,    0, 1132, 1116, 1132, 1120, 1124, 1121, 1123, 1141,
     1139, 1132, 1139, 1117,    0, 1124, 1120, 1125, 1125, 1140,

        0, 1140, 1141,    0, 1141, 1121, 1123, 1147,    0, 1147,
     1124, 1139,    0,    0, 1142, 1142,    0, 1127, 1125,    0,
     1140, 1128, 1130, 1143, 1143, 1131, 1133, 1142, 1144, 1134,
     1144, 1145,    0, 1145, 1132, 1146, 1143, 1146, 1148,    0,
     1148, 1147, 1139,    0, 1151, 1150, 1151, 1150, 1152,    0,
     1152, 1140, 1157,    0, 1157, 1144,    0,    0, 1145, 1147,
        0, 1158, 1146, 1158,    0,    0,    0,    0, 1144, 1150,
     1148, 1145, 1148, 1150,    0, 1146, 1159,    0, 1159, 1157,
     1144,    0, 1150, 1145, 1160,    0, 1160, 1146, 1158, 1161,
     1148, 1161, 1157, 1162,    0, 1162, 1151, 1150,    0,    0,

     1152, 1158, 1160, 1159, 1157, 1160, 1163, 1161, 1163,    0,
     1161, 1162,    0, 1158, 1162, 1164, 1159, 1164, 1168, 1169,
     1168, 1169, 1170, 1172, 1170, 1172,    0, 1168, 1159, 1173,
     1163, 1173, 1174,    0, 1174, 1175, 1160, 1175, 1173,    0,
     1163, 1161, 1177, 1164, 1177, 1162, 1178,    0, 1178, 1176,
     1170, 1176, 1164, 1169, 1179,    0, 1179, 1164, 1163, 1170,
        0, 1169, 1181, 1175, 1181,    0,    0, 1164,    0, 1175,
     1168, 1169,    0,    0, 1170, 1172, 1180, 1176, 1180,    0,
        0, 1173,    0,    0, 1174,    0, 1176, 1175, 1179,    0,
     1176,    0,    0,    0, 1177, 1179, 1181,    0, 1178,    0,

        0, 1176,    0,    0, 1180,    0, 1179,    0,    0,    0,
        0,    0,    0, 1180, 1181,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 1180, 1183,
     1183, 1183, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1185,
     1185, 1185, 1185, 1185, 1185, 1185, 1186, 1186, 1186, 1186,
     1187, 1187, 1187, 1187, 1187, 1187, 1188, 1188, 1188, 1188,
     1188, 1189, 1189, 1189, 1189, 1190, 1190, 1190, 1190,    0,
     1190, 1191, 1191, 1191,    0, 1191, 1191, 1192, 1192, 1192,
        0, 1192, 1193, 1193, 1194, 1194, 1194,    0,    0, 1194,
     1195, 1195,    0,    0, 1195, 1195, 1195, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182
    } ;

static yy_state_type yy_last_accepting_state;
static YY_CHAR *yy_last_accepting_cpos;

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static YY_CHAR *yy_full_match;
static int yy_lp;
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
++yy_lp; \
goto find_rule; \
}
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0

/* these variables are all declared out here so that section 3 code can
 * manipulate them
 */
/* points to current character in buffer */
static YY_CHAR *yy_c_buf_p = (YY_CHAR *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yyunput YY_PROTO(( YY_CHAR c, YY_CHAR *buf_ptr ));
void yyrestart YY_PROTO(( FILE *input_file ));
void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));

#define yy_new_buffer yy_create_buffer

#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif

YY_DECL
    {
    register yy_state_type yy_current_state;
    register YY_CHAR *yy_cp, *yy_bp;
    register int yy_act;



   { /* if (nnextstart) {
           nextline += support ; 
           nextstart = nnextstart ;
           nnextstart = support = 0 ; } */

     if (next==1) {
        next = 0 ;
        last = (dontlast==0) ;
        dontlast = 0 ;
        return code ; }

     if (itflag)
        in_trace = in_trace = seek_with = 0 ;
     itflag = (in_trace) ;
     
     tstart = thischar ;
     tline = nextline ;
     prev = last ;
     last = 0 ; }


    if ( yy_init )
	{
	YY_USER_INIT;

	if ( ! yy_start )
	    yy_start = 1;	/* first start state */

	if ( ! yyin )
	    yyin = stdin;

	if ( ! yyout )
	    yyout = stdout;

	if ( yy_current_buffer )
	    yy_init_buffer( yy_current_buffer, yyin );
	else
	    yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_load_buffer_state();

	yy_init = 0;
	}

    while ( 1 )		/* loops until end-of-file is reached */
	{
	yy_cp = yy_c_buf_p;

	/* support of yytext */
	*yy_cp = yy_hold_char;

	/* yy_bp points to the position in yy_ch_buf of the start of the
	 * current run.
	 */
	yy_bp = yy_cp;

	yy_current_state = yy_start;
	yy_state_ptr = yy_state_buf;
	*yy_state_ptr++ = yy_current_state;
yy_match:
	do
	    {
	    register YY_CHAR yy_c = yy_ec[*yy_cp];
	    while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = yy_def[yy_current_state];
		if ( yy_current_state >= 1183 )
		    yy_c = yy_meta[yy_c];
		}
	    yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	    *yy_state_ptr++ = yy_current_state;
	    ++yy_cp;
	    }
	while ( yy_current_state != 1182 );

yy_find_action:
	yy_current_state = *--yy_state_ptr;
	yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backtracking */
	for ( ; ; ) /* until we find what rule we matched */
	    {
	    if ( yy_lp && yy_lp < yy_accept[yy_current_state + 1] )
		{
		yy_act = yy_acclist[yy_lp];
		    {
		    yy_full_match = yy_cp;
		    break;
		    }
		}
	    --yy_cp;
	    yy_current_state = *--yy_state_ptr;
	    yy_lp = yy_accept[yy_current_state];
	    }

	YY_DO_BEFORE_ACTION;
	YY_USER_ACTION;

do_action:	/* this label is used only to access EOF actions */


	switch ( yy_act )
	    {
case 1:
;
	YY_BREAK
case 2:
{
   nextstart = thischar ;   
   return STATSEP ; }
	YY_BREAK
case 3:
{
   BEGIN comm ;
   if (obs_with==1)
      exiterror( 38 ) ;
   obs_with = in_do = 0 ;
   in_parse = 0 ;
   nextstart = thischar ;   
   return STATSEP ; }
	YY_BREAK
case 4:
{
   exiterror( 21 ) ; }
	YY_BREAK
case 5:
{
   BEGIN value1 ;
   return ADDRESS ; }
	YY_BREAK
case 6:
{
   BEGIN other ;
   in_parse = 1 ;
   return ARG ; }
	YY_BREAK
case 7:
{
   BEGIN other ;
   return CALL ; }
	YY_BREAK
case 8:
{
   BEGIN do1 ;
   in_do = 1 ;
   return DO ; }
	YY_BREAK
case 9:
{
   BEGIN other ;
   return DROP ; }
	YY_BREAK
case 10:
{
   BEGIN comm ;
   return ELSE ; }
	YY_BREAK
case 11:
{
   BEGIN other ;
   return EXIT ; }
	YY_BREAK
case 12:
{
   BEGIN ifcont ;
   in_then = 1 ;
   return IF ; }
	YY_BREAK
case 13:
{
   BEGIN other ;
   return INTERPRET ; }
	YY_BREAK
case 14:
{
   BEGIN other ;
   return ITERATE ; }
	YY_BREAK
case 15:
{
   BEGIN other ;
   return LEAVE ; }
	YY_BREAK
case 16:
{
   BEGIN nothing ;
   return NOP ; }
	YY_BREAK
case 17:
{
   BEGIN numeric ;
   return NUMERIC ; }
	YY_BREAK
case 18:
{
   BEGIN parse ;
   in_parse = 1 ;
   return PARSE ; }
	YY_BREAK
case 19:
{
   BEGIN procd ;
   return PROCEDURE ; }
	YY_BREAK
case 20:
{
   BEGIN other ;
   in_parse = 1 ;
   return PULL ; }
	YY_BREAK
case 21:
{
   BEGIN other ;
   return PUSH ; }
	YY_BREAK
case 22:
{
   BEGIN other ;
   return QUEUE ; }
	YY_BREAK
case 23:
{
   BEGIN other ;
   return RETURN ; }
	YY_BREAK
case 24:
{
   BEGIN other ;
   return SAY ; }
	YY_BREAK
case 25:
{
   BEGIN nothing ;
   return SELECT ; }
	YY_BREAK
case 26:
{
   BEGIN other ;
   return SIGNAL ; }
	YY_BREAK
case 27:
{
   BEGIN trace ;
   in_trace = 1 ;
   return TRACE ; }
	YY_BREAK
case 28:
{
   BEGIN other ;
   return UPPER ; }
	YY_BREAK
case 29:
{
   BEGIN ifcont ;
   in_then = 1 ;
   return WHEN ; }
	YY_BREAK
case 30:
{
   BEGIN comm ;
   return OTHERWISE ; }
	YY_BREAK
case 31:
{
   BEGIN other ;
   return END ; }
	YY_BREAK
case 32:
{
   BEGIN other ;
   
   j = 0 ;
   for (i=0;yytext[i];i++)
      if ('a' <= yytext[i] && yytext[i] <= 'z')
         retvalue[j++] = yytext[i] & 0xDF ;
      else if (yytext[i]!='=' && yytext[i]!='\t' && yytext[i]!='\n' && yytext[i]!=' ' && yytext[i]!='~')
         retvalue[j++] = yytext[i] ;
   retvalue[j] = 0x00 ;

   return ASSIGNMENTVARIABLE ; }
	YY_BREAK
case 33:
{
   BEGIN other ;
   if (!in_trace)
      obs_with = 1 ;
   return VALUE ; }
	YY_BREAK
case 34:
{
   BEGIN sigtype ;
   return ON ; }
	YY_BREAK
case 35:
{
   BEGIN sigtype ;
   return OFF ; }
	YY_BREAK
case 36:
{
   BEGIN nothing ;
   return ERROR ; }
	YY_BREAK
case 37:
{
   BEGIN nothing ;
   return HALT ; }
	YY_BREAK
case 38:
{
   BEGIN nothing ;
   return NOVALUE ; }
	YY_BREAK
case 39:
{
   BEGIN nothing ;
   return SYNTAX ; }
	YY_BREAK
case 40:
{
   strcpy(retvalue,rmspc( yytext )) ;
   return WHATEVER ; }
	YY_BREAK
case 41:
{
   return BANG ; }
	YY_BREAK
case 42:
{
   return WHAT ; }
	YY_BREAK
case 43:
{
   return ALL ; }
	YY_BREAK
case 44:
{
   return COMMANDS ; }
	YY_BREAK
case 45:
{
   return ERRORS ; }
	YY_BREAK
case 46:
{
   return INTERMEDIATES ; }
	YY_BREAK
case 47:
{
   return LABELS ; }
	YY_BREAK
case 48:
{
   return NORMAL ; }
	YY_BREAK
case 49:
{
   return OFF ; }
	YY_BREAK
case 50:
{
   return RESULTS ; }
	YY_BREAK
case 51:
{
   return SCAN ; }
	YY_BREAK
case 52:
{
   BEGIN other ;
   in_parse = 1 ;
   return EXPOSE ; }
	YY_BREAK
case 53:
{
   return UPPER ; }
	YY_BREAK
case 54:
{
   BEGIN other ;
   return ARG ; }
	YY_BREAK
case 55:
{
   BEGIN other ;
   return NUMERIC ; }
	YY_BREAK
case 56:
{
   BEGIN other ;
   return PULL ; }
	YY_BREAK
case 57:
{
   BEGIN other ;
   return SOURCE ; }
	YY_BREAK
case 58:
{
   BEGIN other ;
   return EXTERNAL ; }
	YY_BREAK
case 59:
{
   BEGIN other ;
   return LINEIN ; }
	YY_BREAK
case 60:
{
   BEGIN other ;
    return VERSION ; }
	YY_BREAK
case 61:
{
   BEGIN other ;
   return VAR ; }
	YY_BREAK
case 62:
{
   seek_with = 1 ;
   in_trace = 0 ;
   BEGIN with ;
   return VALUE ; }
	YY_BREAK
case 63:
{
   if (in_then!=1) REJECT
   BEGIN comm ;
   in_then = 0 ;
   return THEN ; }
	YY_BREAK
case 64:
{
   BEGIN other ;
   if ((!in_parse)||(in_do)||(!seek_with)) 
      REJECT ;
   seek_with = 0 ;
   return WITH ; }
	YY_BREAK
case 65:
{
   BEGIN other ;
   return DIGITS ; }
	YY_BREAK
case 66:
{
   return FORM ; }
	YY_BREAK
case 67:
{
   return SCIENTIFIC ; }
	YY_BREAK
case 68:
{
   return ENGINEERING ; }
	YY_BREAK
case 69:
{
   BEGIN other ;
   return FUZZ ; }
	YY_BREAK
case 70:
{
   BEGIN other ;
   return FOREVER ; }
	YY_BREAK
case 71:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
{
   BEGIN other ;
   strcpy(retvalue,rmspc( yytext )) ;
   return DOVARIABLE ; }   
	YY_BREAK
case 72:
{
   if (in_do) {
      BEGIN other ;
      return TO ; }
   REJECT ; }
	YY_BREAK
case 73:
{
   if (in_do) {
      BEGIN other ; 
      return BY ; }
   REJECT ; }
	YY_BREAK
case 74:
{
   if (in_do) {
      BEGIN other ;
      return FOR ; }
   REJECT ; }
	YY_BREAK
case 75:
{
   if (in_do) {
      BEGIN other ;
      return WHILE ; }
   REJECT ; }
	YY_BREAK
case 76:
{
   if (in_do) {
      BEGIN other ;
      return UNTIL ; }
   REJECT ; }
	YY_BREAK
case 77:
{ 
   BEGIN comm ;
   
   for (i=j=0;ch=yytext[i];i++) {
      if ('a' <= ch && ch <= 'z')
         retvalue[j++] = ch & 0xDF ;
      else if ((ch!=' ')&&(ch!=',')&&(ch!='\t')&&(ch!='\n')&&(ch!=':')&&(ch!='~'))
         retvalue[j++] = ch ; }
   retvalue[j] = 0x00 ;
  /* nnextline = nextline ;
   nnextstart = thischar ;   
   nextstart = tstart ; 
   support = nextline - tline ;
   nextline = tline ; */
   return LABEL ; }
	YY_BREAK
case 78:
{
   BEGIN other ;
   char1 = yytext[0] ;
   for (i=1; yytext[i+1]!='('; i++)
      if (yytext[i]==char1 && yytext[i+1]==char1)
         for (j=i+1; yytext[j]; j++)
            yytext[j] = yytext[j+1] ;
   yytext[i] = 0x00 ;
   strcpy(retvalue,&yytext[1]) ;

   if (prev==1) {
      next = dontlast = 1 ;
      code = INFUNCNAME ;
      return CONCATENATE ; }

   last = 0 ;
   return EXFUNCNAME ; }
	YY_BREAK
case 79:
{   /* buggy */ 
   BEGIN other ; 
   for (i=0;yytext[i]!='(';i++) 
      if ('a' <= yytext[i] && yytext[i] <= 'z')
         retvalue[i] = yytext[i] & 0xDF ;
      else
         retvalue[i] = yytext[i] ;
   retvalue[i] = 0x00 ;

   if (prev==1) {
      next = dontlast = 1 ;
      code = INFUNCNAME ;
      return CONCATENATE ; }

   last = 0 ;
   return INFUNCNAME ; }
	YY_BREAK
case 80:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
{
   BEGIN other ;
   for (i=j=1;yytext[i];i++)
      if (!isspace(yytext[i]))
         yytext[j++] = yytext[i] ; 

   flag=((j/2)*2==j) ;
   for (sum=i=k=0;(((ch=yytext[++i])!='\'')&&(ch!='"'));) {
      if ((ch>='0')&&(ch<='9')) {
         sum = sum*16 + (ch-'0') ; }
      else if ((ch>='a')&&(ch<='f')) {
         sum = sum*16 + (ch-'a'+10) ; }
      else if ((ch>='A')&&(ch<='F')) {
         sum = sum*16 + (ch-'A'+10) ; }
      
      if (flag) {
         retvalue[k++] = sum ;
         sum = 0 ; }
      flag = !flag ; }

   retvalue[k] = 0x00 ;

   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = STRING ;
      return CONCATENATE ; }

   last = 1 ;
   return HEXSTRING ; }
	YY_BREAK
case 81:
{ 
   BEGIN other ;
   char1 = yytext[0] ;
   for (i=1; yytext[i+1]; i++)
      if (yytext[i]==char1 && yytext[i+1]==char1)
         for (j=i+1; yytext[j]; j++)
            yytext[j] = yytext[j+1] ;

   yytext[strlen(yytext)-1] = 0x00 ;
   strcpy(retvalue,&yytext[1]) ;

   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = STRING ;
      return CONCATENATE ; }

   last = 1 ;
   return STRING ; }
	YY_BREAK
case 82:
{
   if ((in_parse)&&(!in_do)&&(!seek_with))
      REJECT ;
   BEGIN other ;
   for (i=0;yytext[i];i++)
      if ('a' <= yytext[i] && yytext[i] <= 'z')
         retvalue[i] = yytext[i] & 0xDF ;
      else
         retvalue[i] = yytext[i] ;
   retvalue[i] = 0x00 ;

   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = CONSYMBOL ;
      return CONCATENATE ; }

   last = 1 ;
   return CONSYMBOL ; }
	YY_BREAK
case 83:
{
   strcpy(retvalue,yytext) ;
   return OFFSET ; }
	YY_BREAK
case 84:
{
   if (in_trace) REJECT ;
   BEGIN other ;
   for (i=0;yytext[i];i++)
      if ('a' <= yytext[i] && yytext[i] <= 'z')
         retvalue[i] = yytext[i] & 0xDF ;
      else
         retvalue[i] = yytext[i] ;
   retvalue[i] = 0x00 ;

   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = SIMSYMBOL ;
      return CONCATENATE ; }

   last = 1 ;
   return SIMSYMBOL ; }
	YY_BREAK
case 85:
{
   last = 1 ;
   return ')' ; }
	YY_BREAK
case 86:
{
   if (prev==1) {
      next = 1 ;
      code = '(' ;
      return CONCATENATE ; }

   return '(' ; }
	YY_BREAK
case 87:
{
   return ',' ; }
	YY_BREAK
case 88:
{
   BEGIN other ;
   return '-' ; }
	YY_BREAK
case 89:
{
   BEGIN other ;
   return '+' ; }
	YY_BREAK
case 90:
{
   return '/' ; }
	YY_BREAK
case 91:
{
   return '%' ; }
	YY_BREAK
case 92:
{
   return '*' ; }
	YY_BREAK
case 93:
{
   return '|' ; }
	YY_BREAK
case 94:
{
   return '&' ; }
	YY_BREAK
case 95:
{
   return '=' ; }
	YY_BREAK
case 96:
{
   BEGIN other ;
   return NOT ; }
	YY_BREAK
case 97:
{
   return GT ; }
	YY_BREAK
case 98:
{
   return GTE ; }
	YY_BREAK
case 99:
{
   return LT ; }
	YY_BREAK
case 100:
{
   return LTE ; }
	YY_BREAK
case 101:
{
   return DIFFERENT ; }
	YY_BREAK
case 102:
{
   return EQUALEQUAL ; }
	YY_BREAK
case 103:
{
   return NOTEQUALEQUAL ; }
	YY_BREAK
case 104:
{ 
   return MODULUS ; } 
	YY_BREAK
case 105:
{ 
   return XOR ; }	
	YY_BREAK
case 106:
{ 
   return CONCATENATE ; }
	YY_BREAK
case 107:
{ 
   return EXP ; } 
	YY_BREAK
case 108:
{
   return PLACEHOLDER ; }
	YY_BREAK
case 109:
{ 
   return (((in_parse)&&(!seek_with)) ? yylex() : SPACE) ; }
	YY_BREAK
case 110:
{
                             exiterror( 13 ) ; }
	YY_BREAK
case 111:
{ printf("DEBUG UNRECOGNIZED CHAR //%s//\n",yytext) ; }
	YY_BREAK
case 112:
ECHO;
	YY_BREAK
	    case YY_STATE_EOF(INITIAL):
	    case YY_STATE_EOF(nothing):
	    case YY_STATE_EOF(comm):
	    case YY_STATE_EOF(trace):
	    case YY_STATE_EOF(signal):
	    case YY_STATE_EOF(sigtype):
	    case YY_STATE_EOF(procd):
	    case YY_STATE_EOF(parse):
	    case YY_STATE_EOF(then):
	    case YY_STATE_EOF(with):
	    case YY_STATE_EOF(numeric):
	    case YY_STATE_EOF(do1):
	    case YY_STATE_EOF(other):
	    case YY_STATE_EOF(value1):
	    case YY_STATE_EOF(ifcont):
		yyterminate();

	    case YY_END_OF_BUFFER:
		{
		/* amount of text matched not including the EOB char */
		int yy_amount_of_matched_text = yy_cp - yytext - 1;

		/* undo the effects of YY_DO_BEFORE_ACTION */
		*yy_cp = yy_hold_char;

		/* note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the end-
		 * of-buffer state).  Contrast this with the test in yyinput().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
		    /* this was really a NUL */
		    {
		    yy_state_type yy_next_state;

		    yy_c_buf_p = yytext + yy_amount_of_matched_text;

		    yy_current_state = yy_get_previous_state();

		    /* okay, we're now positioned to make the
		     * NUL transition.  We couldn't have
		     * yy_get_previous_state() go ahead and do it
		     * for us because it doesn't know how to deal
		     * with the possibility of jamming (and we
		     * don't want to build jamming into it because
		     * then it will run more slowly)
		     */

		    yy_next_state = yy_try_NUL_trans( yy_current_state );

		    yy_bp = yytext + YY_MORE_ADJ;

		    if ( yy_next_state )
			{
			/* consume the NUL */
			yy_cp = ++yy_c_buf_p;
			yy_current_state = yy_next_state;
			goto yy_match;
			}

		    else
			{
			goto yy_find_action;
			}
		    }

		else switch ( yy_get_next_buffer() )
		    {
		    case EOB_ACT_END_OF_FILE:
			{
			yy_did_buffer_switch_on_eof = 0;

			if ( yywrap() )
			    {
			    /* note: because we've taken care in
			     * yy_get_next_buffer() to have set up yytext,
			     * we can now set up yy_c_buf_p so that if some
			     * total hoser (like flex itself) wants
			     * to call the scanner after we return the
			     * YY_NULL, it'll still work - another YY_NULL
			     * will get returned.
			     */
			    yy_c_buf_p = yytext + YY_MORE_ADJ;

			    yy_act = YY_STATE_EOF((yy_start - 1) / 2);
			    goto do_action;
			    }

			else
			    {
			    if ( ! yy_did_buffer_switch_on_eof )
				YY_NEW_FILE;
			    }
			}
			break;

		    case EOB_ACT_CONTINUE_SCAN:
			yy_c_buf_p = yytext + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			yy_cp = yy_c_buf_p;
			yy_bp = yytext + YY_MORE_ADJ;
			goto yy_match;

		    case EOB_ACT_LAST_MATCH:
			yy_c_buf_p =
			    &yy_current_buffer->yy_ch_buf[yy_n_chars];

			yy_current_state = yy_get_previous_state();

			yy_cp = yy_c_buf_p;
			yy_bp = yytext + YY_MORE_ADJ;
			goto yy_find_action;
		    }
		break;
		}

	    default:
#ifdef FLEX_DEBUG
		printf( "action # %d\n", yy_act );
#endif
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	    }
	}
    }


/* yy_get_next_buffer - try to read in a new buffer
 *
 * synopsis
 *     int yy_get_next_buffer();
 *     
 * returns a code representing an action
 *     EOB_ACT_LAST_MATCH - 
 *     EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *     EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()

    {
    register YY_CHAR *dest = yy_current_buffer->yy_ch_buf;
    register YY_CHAR *source = yytext - 1; /* copy prev. char, too */
    register int number_to_move, i;
    int ret_val;

    if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
	YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

    /* try to read more data */

    /* first move last chars to start of buffer */
    number_to_move = yy_c_buf_p - yytext;

    for ( i = 0; i < number_to_move; ++i )
	*(dest++) = *(source++);

    if ( yy_current_buffer->yy_eof_status != EOF_NOT_SEEN )
	/* don't do the read, it's not guaranteed to return an EOF,
	 * just force an EOF
	 */
	yy_n_chars = 0;

    else
	{
	int num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;

	if ( num_to_read > YY_READ_BUF_SIZE )
	    num_to_read = YY_READ_BUF_SIZE;

	else if ( num_to_read <= 0 )
	    YY_FATAL_ERROR( "fatal error - scanner input buffer overflow" );

	/* read in more data */
	YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
		  yy_n_chars, num_to_read );
	}

    if ( yy_n_chars == 0 )
	{
	if ( number_to_move - YY_MORE_ADJ == 1 )
	    {
	    ret_val = EOB_ACT_END_OF_FILE;
	    yy_current_buffer->yy_eof_status = EOF_DONE;
	    }

	else
	    {
	    ret_val = EOB_ACT_LAST_MATCH;
	    yy_current_buffer->yy_eof_status = EOF_PENDING;
	    }
	}

    else
	ret_val = EOB_ACT_CONTINUE_SCAN;

    yy_n_chars += number_to_move;
    yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
    yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

    /* yytext begins at the second character in yy_ch_buf; the first
     * character is the one which preceded it before reading in the latest
     * buffer; it needs to be kept around in case it's a newline, so
     * yy_get_previous_state() will have with '^' rules active
     */

    yytext = &yy_current_buffer->yy_ch_buf[1];

    return ( ret_val );
    }


/* yy_get_previous_state - get the state just before the EOB char was reached
 *
 * synopsis
 *     yy_state_type yy_get_previous_state();
 */

static yy_state_type yy_get_previous_state()

    {
    register yy_state_type yy_current_state;
    register YY_CHAR *yy_cp;

    yy_current_state = yy_start;
    yy_state_ptr = yy_state_buf;
    *yy_state_ptr++ = yy_current_state;

    for ( yy_cp = yytext + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
	{
	register YY_CHAR yy_c = (*yy_cp ? yy_ec[*yy_cp] : 1);
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
	    {
	    yy_current_state = yy_def[yy_current_state];
	    if ( yy_current_state >= 1183 )
		yy_c = yy_meta[yy_c];
	    }
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	*yy_state_ptr++ = yy_current_state;
	}

    return ( yy_current_state );
    }


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *     next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( register yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
register yy_state_type yy_current_state;
#endif

    {
    register int yy_is_jam;

    register YY_CHAR yy_c = 1;
    while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
	{
	yy_current_state = yy_def[yy_current_state];
	if ( yy_current_state >= 1183 )
	    yy_c = yy_meta[yy_c];
	}
    yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
    *yy_state_ptr++ = yy_current_state;
    yy_is_jam = (yy_current_state == 1182);

    return ( yy_is_jam ? 0 : yy_current_state );
    }


#ifdef YY_USE_PROTOS
static void yyunput( YY_CHAR c, register YY_CHAR *yy_bp )
#else
static void yyunput( c, yy_bp )
YY_CHAR c;
register YY_CHAR *yy_bp;
#endif

    {
    register YY_CHAR *yy_cp = yy_c_buf_p;

    /* undo effects of setting up yytext */
    *yy_cp = yy_hold_char;

    if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
	{ /* need to shift things up to make room */
	register int number_to_move = yy_n_chars + 2; /* +2 for EOB chars */
	register YY_CHAR *dest =
	    &yy_current_buffer->yy_ch_buf[yy_current_buffer->yy_buf_size + 2];
	register YY_CHAR *source =
	    &yy_current_buffer->yy_ch_buf[number_to_move];

	while ( source > yy_current_buffer->yy_ch_buf )
	    *--dest = *--source;

	yy_cp += dest - source;
	yy_bp += dest - source;
	yy_n_chars = yy_current_buffer->yy_buf_size;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
	    YY_FATAL_ERROR( "flex scanner push-back overflow" );
	}

    if ( yy_cp > yy_bp && yy_cp[-1] == '\n' )
	yy_cp[-2] = '\n';

    *--yy_cp = c;

    /* note: the formal parameter *must* be called "yy_bp" for this
     *       macro to now work correctly
     */
    YY_DO_BEFORE_ACTION; /* set up yytext again */
    }


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif

    {
    int c;
    YY_CHAR *yy_cp = yy_c_buf_p;

    *yy_cp = yy_hold_char;

    if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
	{
	/* yy_c_buf_p now points to the character we want to return.
	 * If this occurs *before* the EOB characters, then it's a
	 * valid NUL; if not, then we've hit the end of the buffer.
	 */
	if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
	    /* this was really a NUL */
	    *yy_c_buf_p = '\0';

	else
	    { /* need more input */
	    yytext = yy_c_buf_p;
	    ++yy_c_buf_p;

	    switch ( yy_get_next_buffer() )
		{
		case EOB_ACT_END_OF_FILE:
		    {
		    if ( yywrap() )
			{
			yy_c_buf_p = yytext + YY_MORE_ADJ;
			return ( EOF );
			}

		    YY_NEW_FILE;

#ifdef __cplusplus
		    return ( yyinput() );
#else
		    return ( input() );
#endif
		    }
		    break;

		case EOB_ACT_CONTINUE_SCAN:
		    yy_c_buf_p = yytext + YY_MORE_ADJ;
		    break;

		case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
		    YY_FATAL_ERROR( "unexpected last match in yyinput()" );
#else
		    YY_FATAL_ERROR( "unexpected last match in input()" );
#endif
		}
	    }
	}

    c = *yy_c_buf_p;
    yy_hold_char = *++yy_c_buf_p;

    return ( c );
    }


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif

    {
    yy_init_buffer( yy_current_buffer, input_file );
    yy_load_buffer_state();
    }


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif

    {
    if ( yy_current_buffer == new_buffer )
	return;

    if ( yy_current_buffer )
	{
	/* flush out information for old buffer */
	*yy_c_buf_p = yy_hold_char;
	yy_current_buffer->yy_buf_pos = yy_c_buf_p;
	yy_current_buffer->yy_n_chars = yy_n_chars;
	}

    yy_current_buffer = new_buffer;
    yy_load_buffer_state();

    /* we don't actually know whether we did this switch during
     * EOF (yywrap()) processing, but the only time this flag
     * is looked at is after yywrap() is called, so it's safe
     * to go ahead and always set it.
     */
    yy_did_buffer_switch_on_eof = 1;
    }


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif

    {
    yy_n_chars = yy_current_buffer->yy_n_chars;
    yytext = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
    yyin = yy_current_buffer->yy_input_file;
    yy_hold_char = *yy_c_buf_p;
    }


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif

    {
    YY_BUFFER_STATE b;

    b = (YY_BUFFER_STATE) malloc( sizeof( struct yy_buffer_state ) );

    if ( ! b )
	YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

    b->yy_buf_size = size;

    /* yy_ch_buf has to be 2 characters longer than the size given because
     * we need to put in 2 end-of-buffer characters.
     */
    b->yy_ch_buf = (YY_CHAR *) malloc( (unsigned) (b->yy_buf_size + 2) );

    if ( ! b->yy_ch_buf )
	YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

    yy_init_buffer( b, file );

    return ( b );
    }


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif

    {
    if ( b == yy_current_buffer )
	yy_current_buffer = (YY_BUFFER_STATE) 0;

    free( (char *) b->yy_ch_buf );
    free( (char *) b );
    }


#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif

    {
    b->yy_input_file = file;

    /* we put in the '\n' and start reading from [1] so that an
     * initial match-at-newline will be true.
     */

    b->yy_ch_buf[0] = '\n';
    b->yy_n_chars = 1;

    /* we always need two end-of-buffer characters.  The first causes
     * a transition to the end-of-buffer state.  The second causes
     * a jam in that state.
     */
    b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
    b->yy_ch_buf[2] = YY_END_OF_BUFFER_CHAR;

    b->yy_buf_pos = &b->yy_ch_buf[1];

    b->yy_eof_status = EOF_NOT_SEEN;
    }


#define NORMALSTAT  0
#define COMMENTSTAT 1
#define SINGLEQUOTE 2
#define DOUBLEQUOTE 3

void myungetc( int ch, FILE *str ) ;
int xxstate=NORMALSTAT, linenr=1 ;
nodeptr currentnode ;

char *rmspc( char *instr ) 
{
   char ch ;
   int i, j=0 ;

   for (i=0;instr[i];i++) {
      ch = instr[i] ;
      if ('a' <= ch && ch <= 'z')
         instr[j++] = ch & 0xDF ;
      else if ((ch!=' ') && (ch!=',') && (ch!='\t') && (ch!='\n'))
         instr[j++] = ch ; }
   instr[j] = 0x00 ;
 
   return( instr ) ;
}


int bufptr=0 ;
char chbuffer[LOOKAHEAD] ;
lineboxptr firstline=NULL, lastline=NULL ;
int ipretflag=0, cch=0 ;
char *interptr=NULL ;

void initinterpret( char *str )
{
   extern char *interptr ; 
#ifdef FLEX_SCANNER
   extern int yy_init ;
#endif
   extern int ipretflag, cch ;

   cch = 0 ;
   ipretflag = 1 ;
#ifdef FLEX_SCANNER
   yy_init = 1 ;
#endif
   BEGIN comm ;
   interptr = str ;
}


void initvalue( char *str )
{
   extern int isvalue, yy_start ;
#ifdef FLEX_SCANNER
   extern int yy_init ;
#endif
   
   initinterpret( str ) ;
   BEGIN other ;
#ifdef FLEX_SCANNER
   yy_init = 1 ;
#endif
}


int mygetc( FILE *str )
{
   extern int xxstate, nextline ;
   extern lineboxptr firstline, lastline ;
   lineboxptr newline ;
   extern int linenr, bufptr ;
   extern char chbuffer[] ;
   extern int cch ;
   extern int thischar ;
   static char thisline[BUFFERSIZE] ;
   int nextchar ;
   extern int ipretflag ;
   extern char *interptr ;

   if (bufptr>0) 
      return chbuffer[--bufptr] ;
   else if (ipretflag) {
      if ((!(thisline[cch++]=nextchar=*interptr++)) && xxstate!=NORMALSTAT)
         exiterror( 6 ) ; 
      else
         if (nextchar==0x00) {
            myungetc(EOF,yyin) ;
            return 0x0a ; } ; }
   else
      if (((thisline[cch++]=nextchar=getc(str))==EOF) && xxstate!=NORMALSTAT)
         exiterror( 6 ) ; 

   thisline[cch] = nextchar = (nextchar) ? nextchar : EOF ;
   thischar++ ;
   if (nextchar=='\n')
      nextline++ ;

   if (cch>=BUFFERSIZE) 
      exiterror(12) ;

   if (nextchar=='\n') {
      thischar = 0 ;
      thisline[--cch] = 0x00 ;
      newline = (lineboxptr)Malloc(sizeof(linebox)) ;
      newline->line = Malloc(cch+1) ;
      memcpy(newline->line,thisline,cch+1) ;
      newline->prev = lastline ;
      newline->next = NULL ;
      newline->lineno = linenr++ ; 
      cch = 0 ;
      if (firstline==NULL) 
         firstline = newline ;
      else
         lastline->next = newline; 
      lastline = newline ; }

   return ( nextchar ) ;
}


static int first=0, singlequote=0, doblequote=0, wascomment=0, lastone=0 ; 

void myungetc( int ch, FILE *str )
{
   extern int linenr, bufptr ;
   extern char chbuffer[] ;

   chbuffer[bufptr++] = (char) ch ;
}


int mygetchar()
{
   static char buff[BUFFERSIZE] ;
   int ptr=0, this ;
   static int prev, haveprev=0 ;
   extern FILE *yyin ;
   extern int first, singlequote, doblequote, wascomment, lastone ;

   if (haveprev==1) {
      haveprev = 0 ;
      this=prev ; }
   else
      this = mmygetchar() ;

   if ((this==',')&&(!singlequote)&&(!doblequote)) {
      this = mmygetchar() ;
      while ((this==' ')||(this=='\t')||(this=='~')) {
         this = mmygetchar() ; }

      if (this=='\n') 
         return (int)' ' ;

      prev = this ;
      haveprev = 1 ;
      return (int)',' ; }

   return this ;
}


int mmygetchar()
{
   int this, next, oldstate, comment, lev ;
   extern FILE *yyin ;
   extern int xxstate ;
   extern int first, singlequote, doblequote, wascomment, lastone ; 

   this = mygetc( yyin ) ;

   if (first==0) {
      first = 1 ;
      if (this=='#') {
         for (;mygetc(yyin)!='\n';) ;
         if ((this=mygetc(yyin))==EOF)
            exiterror( 6 ) ; } ; }

   if ((this=='\'')&&(doblequote==0))
      singlequote = (singlequote==0) ;

   if ((this=='"')&&(singlequote==0))
      doblequote = (doblequote==0) ;

   if ((this=='~')&&(singlequote==0)&&(doblequote==0))
      exiterror(13) ;

   if ((this=='/')&&(singlequote==0)&&(doblequote==0)) {
      if ((next = mygetc(yyin))=='*') {
         for (lev=1;lev>0;) {
            if ((next=mygetc(yyin))=='*') {
               if ((next=mygetc(yyin))=='/')
                  lev-- ;
               else
                  myungetc(next,yyin) ; }
#ifdef NESTEDCOMMENTS
            else if (next=='/') {
               if ((next=mygetc(yyin))=='*')
                  lev++ ;
               else
                  myungetc(next,yyin) ; }
#endif
               }
         this = '~' ; }
      else
         myungetc(next,yyin) ; }

   return( lastone=this ) ;
}


void initscanner()
{
#ifdef FLEX_SCANNER
   yy_init = 1 ;
#endif
   BEGIN comm ;
}


void striptext( char *text )
{
   int i, j=0 ;

   for (i=0; text[i]; i++) {
      if ('a' <= text[i] && text[i] <= 'z')
         text[i] &= 0xDF ;
      if (('A'<=text[i] && text[i]<='Z'))
         text[j++] = text[i] ; }

   text[j] = 0x00 ;
}
